// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "NineK2.h"
#include "ChildView.h"
#include ".\childview.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



///////////////////////////////////////////////////////////////////////////////
//	       
///////////////////////////////////////////////////////////////////////////////
UINT GOCOMP(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->GoComp();
	pWnd->m_CountProcess--;

	return 0;
}

UINT BEGINGAME(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->BeginGame();
	pWnd->m_CountProcess--;

	return 0;
}

UINT GOUSER(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->GoUser();
	pWnd->m_CountProcess--;

	return 0;
}

UINT ROLLPLAYER(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->RollingPlayer();
	pWnd->m_CountProcess--;

	return 0;
}
UINT ONENDGAME(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->OnEndGame();
	pWnd->m_CountProcess--;

	return 0;
}

//    
UINT TESTANIM(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->TestAnim();
	pWnd->m_CountProcess--;
	return 0;
}


// CChildView
CChildView::CChildView()
: m_GOINGPLAYER(0)
, m_NumberGames(0)
, m_pCardUser(NULL)
, m_CountProcess(0)
, m_StopProcess(false)
, m_EnableNextGame(FALSE)
, m_EnableNewParty(TRUE)
{
}

CChildView::~CChildView()
{
	WriteSettingToReg();
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_TIMER()
	ON_COMMAND(ID_FILE_NEWPARTY, OnFileNewparty)
	ON_MESSAGE(WM_CARDLBUTTONDOWN, OnCardLButtonDown)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_FILE_NEXTGAME, OnFileNextgame)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEXTGAME, OnUpdateFileNextgame)
	ON_COMMAND(ID_FILE_STATISTICS, OnFileStatistics)

	ON_MESSAGE(WM_PAGESETTING, OnPublicSetting)
	ON_COMMAND(ID_FILE_SETPLAYERSNAMES, OnFileSetplayersnames)
	ON_WM_CONTEXTMENU()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_SETTING, OnSetting)
	ON_COMMAND(ID_HELPAPP, OnHelpApp)

	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style |= WS_CLIPCHILDREN;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), NULL, NULL);

	return TRUE;
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	// --        

	m_Decoration.m_NUMBERPLAYERS = 4;
	m_Decoration.InitDecoration(this, false);
	
	m_Decoration.m_Pack.CardsToPack();
	m_Decoration.m_Pack.SetPackPos(5, -100);
	m_Decoration.m_Pack.ShufflePack();
	
	m_Decoration.m_mainLabel.SetText(" !");
	
	
	m_wndGameStatistics.InitWnd(this);

	ReadSettingFromReg();

	//              
	if(m_Decoration.m_RequestName == true)
		OnFileSetplayersnames();

	m_Decoration.m_Player[0].SetMoney(m_Decoration.m_maxMoney);
	m_Decoration.m_Player[1].SetMoney(m_Decoration.m_maxMoney);
	m_Decoration.m_Player[2].SetMoney(m_Decoration.m_maxMoney);
	m_Decoration.m_Player[3].SetMoney(m_Decoration.m_maxMoney);

	//m_Decoration.m_Player[0].SetMoney(450);
	//m_Decoration.m_Player[1].SetMoney(660);
	//m_Decoration.m_Player[2].SetMoney(700);
	//m_Decoration.m_Player[3].SetMoney(740);


	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//    
//////////////////////////////////////////////////////////////////////////////////////////////////

void CChildView::OnFileNewparty()
{
	if(m_EnableNewParty == TRUE)
	{
		//  ,   
		m_EnableNewParty = FALSE;

		NewParty();
	}
	else if(m_Decoration.MessageWnd("  ?\n   !", CMessageBox::MMB_YESNO) == IDOK)
	{
		//    
		StopGame();
		//       
		SetTimer(ID_TIMER_WAITNEWPARTY, 0, NULL);

	}
		
}


//      
void CChildView::ResetNewParty(void)
{
	m_NumberGames = 0;

	for(int p = 0; p < m_Decoration.m_NUMBERPLAYERS; p++)
	{
		m_Decoration.m_Player[p].SetMoney(m_Decoration.m_maxMoney);
		m_Decoration.m_Player[p].SetNumberRoll(0);
		m_Decoration.m_Player[p].SetNumberVictory(0);
	}

	/*m_Decoration.m_Player[0].SetMoney(50);
	m_Decoration.m_Player[1].SetMoney(600);
	m_Decoration.m_Player[2].SetMoney(100);
	m_Decoration.m_Player[3].SetMoney(1200);*/

	
	m_Decoration.m_BankGame.SetMoney(0);
	
	if(m_GOINGPLAYER == 0)
		m_GOINGPLAYER = 2;
}

//   
void CChildView::NewParty(void)
{
	ResetNewParty();
	
	AfxBeginThread(BEGINGAME, this);
}

void CChildView::OnFileNextgame()
{
	//     " ",
	m_EnableNextGame = FALSE;

	//    
	//   ,
	//    ,     
	//     
	if(IsStopGame() == true)
	{
		AfxBeginThread(BEGINGAME, this);
	}
	else
	{
		StopGame();
		SetTimer(ID_TIMER_WAITNEXTGAME, 0, NULL);
	}
}

void CChildView::OnUpdateFileNextgame(CCmdUI *pCmdUI)
{
	//  " "    ,   
	pCmdUI->Enable(m_EnableNextGame);
}

//  ,      
void CChildView::BeginGame(void)
{
	//  
	m_Decoration.m_mainLabel.ShowText(false);

	m_NumberGames++;

	CString strTitle;
	
	strTitle = g_CaptionApp + " -  " + IntToStr(m_NumberGames);
	AfxGetMainWnd()->SetWindowText(strTitle);

	//       
	for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
	{
		int player_money = m_Decoration.m_Player[i].GetMoney();
		ASSERT(player_money > 0);
		player_money -= 10;
		m_Decoration.m_Player[i].SetMoney(player_money);
		
		{
			//       
			m_Decoration.AnimMoneyToBank( (i+1) );
		}

		int bank_money = m_Decoration.m_BankGame.GetMoney();
		bank_money += 10;
		m_Decoration.m_BankGame.SetMoney(bank_money);
		
	}


	//    
	DistrCards(m_GOINGPLAYER);
}

//      
//  true         
// false -  ,    , 
//     ,      
//        
bool CChildView::DeterminationGoingPlayer(void)
{
	bool result = false;

	//     ,    
	bool is_cardtable = false;
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			is_cardtable = true;
			break;
		}
	}

	//    ,   ,
	//   -      (   ) 
	//       
	m_GoCards.clear();

	//   
	if(m_NumberGames == 1 && is_cardtable == false)
	{
		//     
		for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
		{
			if(m_Decoration.m_Pack.GetCard(p)->m_Mast == 4 && m_Decoration.m_Pack.GetCard(p)->m_Value == 4)
			{
				m_GOINGPLAYER  = m_Decoration.m_Pack.GetCard(p)->m_Player;
				result = true;
				CARD temp;
				temp.mast =  m_Decoration.m_Pack.GetCard(p)->m_Mast;
				temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
				temp.pos_value = m_Decoration.m_Pack.GetCard(p)->m_PosValue;
				m_GoCards.push_back(temp);
				break;
			}
		}
	}
	//  
	else
	{
		//    
		m_GOINGPLAYER++;
		if(m_GOINGPLAYER > m_Decoration.m_NUMBERPLAYERS)
			m_GOINGPLAYER = 1;

		result = false;
	}

	
	return result;
}

void CChildView::OnTimer(UINT nIDEvent)
{
	//     ,
	//     
	if(nIDEvent == ID_TIMER_MAIN)
	{
		//       ,
		//    
		KillTimer(ID_TIMER_MAIN);
		if(m_StopProcess == true) return;

		//    
		if(DeterminationGoingPlayer() == true)
		{

			if(m_GOINGPLAYER == 1)
			{
				m_Decoration.m_mainLabel.SetText(" !");
				m_Decoration.m_mainLabel.ShowText(true);
			}
			else
			{
				AfxBeginThread(GOCOMP, this);
			}
		}// 
		else
		{
			//     ,  
			if(IsCanGo(m_GOINGPLAYER) == true)
			{
				if(m_GOINGPLAYER == 1)
				{
					m_Decoration.m_mainLabel.SetText(" !");
					m_Decoration.m_mainLabel.ShowText(true);
				}
				else
					AfxBeginThread(GOCOMP, this);
			}
			else
			{
				AfxBeginThread(ROLLPLAYER, this);
			}
			
		}// else if(DeterminationGoingPlayer() == true)
			
	}// if(nIDEvent == ID_TIMER_MAIN)


	if(nIDEvent == ID_TIMER_WAITNEXTGAME)
	{
		//     ,
		//     
		if(IsStopGame() == true)
		{
			KillTimer(ID_TIMER_WAITNEXTGAME);

			ContinueGame();
			AfxBeginThread(BEGINGAME, this);
		}
	}// if(nIDEvent == ID_TIMER_WAITNEXTGAME)



	if(nIDEvent == ID_TIMER_WAITNEWPARTY)
	{
		if(IsStopGame() == true)
		{
			KillTimer(ID_TIMER_WAITNEWPARTY);
			ContinueGame();
			NewParty();
		}
	}

	//        
	m_Decoration.m_mainLabel.OnTimer(nIDEvent);

	CWnd::OnTimer(nIDEvent);
}

//  
void CChildView::GoUser(void)
{
	//     -
	CCard* pCard = m_pCardUser;

	//     
	//       
	static bool is_down = false;
	if(is_down == true) return;
	is_down = true;


	//      
	bool is_endgame = false;
	for(int p = 1; p <= m_Decoration.m_NUMBERPLAYERS; p++)
	{
		if(IsEndCards(p) == true)
		{
			is_endgame = true;
			break;
		}
	}

	//   
	if( is_endgame == true ||
		pCard->m_State  != CPack::StateCards::m_ePlayer ||
		pCard->m_Player != 1 ||
		m_GOINGPLAYER != 1 ||
		m_GoCards.size() == 0)
	{
		goto exit_func;
	}

	//         
	//  
	bool all_right = false;
	for(int i = 0; i < (int)m_GoCards.size(); i++)
	{
		if( pCard->m_Mast  == m_GoCards[i].mast &&
			pCard->m_Value == m_GoCards[i].value)
		{
			all_right = true;
			break;
		}
	}

	//       ,
	//        
	if(all_right == false)
	{
		m_Decoration.m_mainLabel.SetTempText("   !");
		m_Decoration.m_mainLabel.ShowText(true);
		goto exit_func;
	}


	//    ,   
	m_Decoration.m_mainLabel.ShowText(false);
	
	if(pCard != NULL)
	{

		pCard->m_State = CPack::StateCards::m_eTable;
		pCard->BringWindowToTop();
		pCard->CardMoveSound(m_Decoration.m_ptCoordinateTable[pCard->m_Mast-1][pCard->m_Value-1].x,
							m_Decoration.m_ptCoordinateTable[pCard->m_Mast-1][pCard->m_Value-1].y, 1);
		pCard->SetWindowPos(NULL, 0,0,m_Decoration.GetTableCardSize().cx, 
												m_Decoration.GetTableCardSize().cy, SWP_NOMOVE);
		pCard->CardOpen(true, m_Decoration.GetTableCardSize().cx, m_Decoration.GetTableCardSize().cy);

		//         
		pCard->SetWindowPos(&CWnd::wndBottom, 0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);

		//         
		if(IsEndCards(m_GOINGPLAYER) == false)
		{
			//  
			m_GoCards.clear();
			//      
			m_Decoration.RightPlayerCards(1);
			
			//      
			SetTimer(ID_TIMER_MAIN, m_Decoration.m_RateGame, NULL);
		}
		else
		{
			AfxBeginThread(ONENDGAME, this);
		}
	}

exit_func:
	//    
	is_down = false;
}


//     .
// :             ,
//         
//       .
//     ""   .
//         
void CChildView::ComputePosValue(const int player, const int mast)
{
	//  6, 7, , , , 
	//    8, 9, 10  ,
	//       8, 9, 10    .
	//           

	//      
	bool is_6  = false;
	bool is_7  = false;
	bool is_8  = false;
	bool is_9  = false;
	bool is_10 = false;
	bool is_V  = false;
	bool is_D  = false;
	bool is_K  = false;
	bool is_T  = false;

	for(int i  = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{	
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer && m_Decoration.m_Pack.GetCard(i)->m_Player == player)
			if(m_Decoration.m_Pack.GetCard(i)->m_Mast == mast)
			{
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak6)
					is_6 = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak7)
					is_7 = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak8)
					is_8 = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak9)
					is_9 = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak10)
					is_10 = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakV)
					is_V = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakD)
					is_D = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakK)
					is_K = true;
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakT)
					is_T = true;
			}// if(m_Decoration..m_Pack.GetCard(i)->m_Mast == 1)
	}// for(int i = 0; i < m_Decoration..m_Pack.GetNumberCardsInPack(); i++)

	//    8, 9, 10

	
	
	// 1.       
	int koef_T = 0;
	if(is_T == true)
	{
		//     
		koef_T = 7;

		//          (    6)
		//    9 .
		//   
		if(is_K == true)
			koef_T -= 1;
		if(is_D == true)
			koef_T -= 1;
		if(is_V == true)
			koef_T -= 1;
		if(is_10 == true)
			koef_T -= 1;

	}// if(is_T == true)
	else if(is_K == true)
	{
		koef_T = 6;
		if(is_D == true)
			koef_T -= 1;
		if(is_V == true)
			koef_T -= 1;
		if(is_10 == true)
			koef_T -= 1;

	}// if(is_K == true)
	else if(is_D == true)
	{
		koef_T = 5;
		if(is_V == true)
			koef_T -= 1;
		if(is_10 == true)
			koef_T -= 1;

	}// if(is_D == true)
	else if(is_V == true)
	{
		koef_T = 3;
		if(is_10 == true)
			koef_T -= 1;
	}//  if(is_V == true)

	// 2.  6     
	int koef_6 = 0;
	if(is_6 == true)
	{
		koef_6 = 3;
		if(is_7 == true)
			koef_6 -= 1;
		if(is_8 == true)
			koef_6 -= 1;
	}// if(is_6 == true)
	else if(is_7 == true)
	{
		koef_6 = 2;
		if(is_8 == true)
			koef_6 -= 1;
	}// if(is_7 == true)


	//          8, 9, 10, 
	for(int i  = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{	
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer && m_Decoration.m_Pack.GetCard(i)->m_Player == player)
			if(m_Decoration.m_Pack.GetCard(i)->m_Mast == mast)
			{
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak8)
					m_Decoration.m_Pack.GetCard(i)->m_PosValue -= koef_6;

				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak9)
					m_Decoration.m_Pack.GetCard(i)->m_PosValue -= (koef_T + koef_6);
					
				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak10)
				{
					m_Decoration.m_Pack.GetCard(i)->m_PosValue -= koef_T;
				}

				if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakV)
					if(koef_T > 1)
					{
						m_Decoration.m_Pack.GetCard(i)->m_PosValue -= 2;
					}
			}
	}// for(int i  = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
}

//        
void CChildView::AlgorithmPosValue(void)
{
	//         .
	for(int i  = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{	
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak6)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 0;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak7)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 1;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak8)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 2;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak9)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 8;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durak10)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 4;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakV)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 3;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakD)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 2;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakK)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 1;
		if(m_Decoration.m_Pack.GetCard(i)->m_Value == CPack::ValueDurak::m_durakT)
			m_Decoration.m_Pack.GetCard(i)->m_PosValue = 0;
	}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)

	//      
	//         
	for(int p = 1; p <= m_Decoration.m_NUMBERPLAYERS; p++)
		for(int m = 1; m <= 4; m++)
			ComputePosValue(p, m);
	
}


//        
//      (  ).
bool SORTPOSVALUEDIFFICULTGAME(CARD _card1, CARD _card2)
{
	return _card1.pos_value < _card2.pos_value;
}

//        
//    ( ).
bool SORTPOSVALUEEASYGAME(CARD _card1, CARD _card2)
{
	return _card1.pos_value > _card2.pos_value;
}

//   
void CChildView::GoComp(void)
{

	//    ,   
	if(m_Decoration.m_DifficultGame == true)
	{
		//        
		//        
		sort(m_GoCards.begin(), m_GoCards.end(), SORTPOSVALUEDIFFICULTGAME);
	}
	else
	{
		//        
		//        
		sort(m_GoCards.begin(), m_GoCards.end(), SORTPOSVALUEEASYGAME);
	}
	
	
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
			{
				//        
				if(	m_Decoration.m_Pack.GetCard(i)->m_Mast  == m_GoCards[0].mast &&
					m_Decoration.m_Pack.GetCard(i)->m_Value == m_GoCards[0].value)
				{
					m_Decoration.m_Pack.GetCard(i)->m_State = CPack::StateCards::m_eTable;
					m_Decoration.m_Pack.GetCard(i)->BringWindowToTop();
					
					m_Decoration.m_Pack.GetCard(i)->CardMoveSound(
						m_Decoration.m_ptCoordinateTable[m_Decoration.m_Pack.GetCard(i)->m_Mast-1][m_Decoration.m_Pack.GetCard(i)->m_Value-1].x,
						m_Decoration.m_ptCoordinateTable[m_Decoration.m_Pack.GetCard(i)->m_Mast-1][m_Decoration.m_Pack.GetCard(i)->m_Value-1].y, 1);
					
					m_Decoration.m_Pack.GetCard(i)->SetWindowPos(NULL, 0,0,m_Decoration.GetTableCardSize().cx, 
												m_Decoration.GetTableCardSize().cy, SWP_NOMOVE);
					m_Decoration.m_Pack.GetCard(i)->CardOpen(true, m_Decoration.GetTableCardSize().cx, m_Decoration.GetTableCardSize().cy);
					
					//         
					m_Decoration.m_Pack.GetCard(i)->SetWindowPos(&CWnd::wndBottom, 0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
					
					//   
					m_Decoration.RightPlayerCards(m_GOINGPLAYER);

					//       
					if(IsEndCards(m_GOINGPLAYER) == false)
					{
						m_GoCards.clear();
						SetTimer(ID_TIMER_MAIN, m_Decoration.m_RateGame, NULL);
					}
					else
					{
						AfxBeginThread(ONENDGAME, this);
					}
					return;
				}
			}// if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
	}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	
}

//     ,
//         
//         
bool SORTUSERCARDSFORROLL(CCard* _pcard1, CCard* _pcard2)
{
	return _pcard1->GetCardPos().x < _pcard2->GetCardPos().x;
}

//     
void CChildView::RollingUser(void)
{
	//         ,
	//    .
	//          

	//       
	//    
	std::vector<CCard*> sort_x;
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
			{
				sort_x.push_back(m_Decoration.m_Pack.GetCard(i));
			}
	}
	std::sort(sort_x.begin(), sort_x.end(), SORTUSERCARDSFORROLL);

	//      
	for(int roll = 0; roll < (int)sort_x.size(); roll++)
	{
		int y = sort_x[roll]->GetCardPos().y;
		int x = sort_x[roll]->GetCardPos().x;
		sort_x[roll]->CardMove(x, y - 30, true);
		sort_x[roll]->CardMoveSound(sort_x[roll]->GetCardPos().x, y, 2);
	}
}

//   
//       -
//  -
void CChildView::RollingPlayer(void)
{
	if(m_GOINGPLAYER == 1)
	{
		RollingUser();
	}
	else
	{
		for(int i = (m_Decoration.m_Pack.GetNumberCardsInPack()-1); i >= 0; i--)
		{
			if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
				if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
				{
					int x = m_Decoration.m_Pack.GetCard(i)->GetCardPos().x;
					int y = m_Decoration.m_Pack.GetCard(i)->GetCardPos().y;
					switch(m_GOINGPLAYER)
					{
					case 1:
						m_Decoration.m_Pack.GetCard(i)->CardMove(x, y - 30, true);
						break;
					case 2:
						m_Decoration.m_Pack.GetCard(i)->CardMove(x + 30, y, true);
						break;
					case 3:
						m_Decoration.m_Pack.GetCard(i)->CardMove(x, y + 30, true);
						break;
					case 4:
						m_Decoration.m_Pack.GetCard(i)->CardMove(x - 30, y, true);
						break;

					} // switch(m_GOINGPLAYER)

					// 
					m_Decoration.m_Pack.GetCard(i)->CardMoveSound(x, y, 2);

				}
		}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	}// else if(m_GOINGPLAYER == 1)

	//     
	int number_roll = m_Decoration.m_Player[m_GOINGPLAYER-1].GetNumberRoll();
	number_roll++;
	m_Decoration.m_Player[m_GOINGPLAYER-1].SetNumberRoll(number_roll);

	//        
	int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
	if(player_money > 0)
	{
		player_money -= 10;
		m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);

		//       
		m_Decoration.AnimMoneyToBank(m_GOINGPLAYER);


		int bank_money = m_Decoration.m_BankGame.GetMoney();
		bank_money += 10;
		m_Decoration.m_BankGame.SetMoney(bank_money);
	}
	else
	{
		//      ,
		//    ,
		//         
		//  (        ),
		//     ,    0 -  ,
		//     0 -  
		player_money -= 10;
		m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);
	}

	//      
	m_wndGameStatistics.SetStatistics(m_Decoration.m_Player, m_Decoration.m_NUMBERPLAYERS, m_NumberGames);
	
	//        
	SetTimer(ID_TIMER_MAIN, m_Decoration.m_RateGame, NULL);

}


//  
void CChildView::DistrCards(const int& distr_player)
{
again_distr:

	m_Decoration.m_Pack.ShufflePack();
	m_Decoration.m_Pack.CardsToPack();

	//  
	m_Decoration.DoDistr(distr_player);

	//      4   4  -(-) (),
	//     -  
	if(m_Decoration.Check4Nine4Tuz() == true)
	{
		goto again_distr;
	}


	//     ,   
	//         
	if(m_Decoration.m_DifficultGame == true)
		//    
		AlgorithmPosValue();

	SetTimer(ID_TIMER_MAIN, m_Decoration.m_RateGame, NULL);
}


//     
LRESULT CChildView::OnCardLButtonDown(WPARAM wParam, LPARAM lParam)
{
	//   m_pCardUser  ,   
	// GoUser   ,       
	//  GOUSER,        CChildView
	m_pCardUser = (CCard*)wParam;
	if(m_pCardUser != NULL)
		//        
		AfxBeginThread(GOUSER, this);

	return LRESULT();
}



BOOL CChildView::OnEraseBkgnd(CDC* pDC)
{
	CRect rc;
	GetClientRect(&rc);

	//      
	m_Decoration.SetDC(pDC);

	//      
	m_Decoration.m_mainLabel.Draw(pDC);
	


	return CWnd::OnEraseBkgnd(pDC);
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	//          
	//     
	//          
	m_Decoration.OnSize(cx, cy);

	m_Decoration.m_mainLabel.SetPos(cx/2, cy/2 - m_Decoration.m_mainLabel.GetTextRect().Height()/2 - 4, 1);

	for(int p = 1; p <= m_Decoration.m_NUMBERPLAYERS; p++)
	{
		m_Decoration.RightPlayerCards(p);
	}
			
	m_Decoration.OnSize(cx, cy);	

	//      
	m_wndGameStatistics.SetWndPos(cx/2, cy/2, true);

}

//       
bool CChildView::IsCanGo(const int go_player)
{
	//  
	m_GoCards.clear();

	//    .
	//           
	//     ,
	// 	    
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
			{
				if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
					if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
						if( m_Decoration.m_Pack.GetCard(p)->m_Mast  == m_Decoration.m_Pack.GetCard(i)->m_Mast &&
							(m_Decoration.m_Pack.GetCard(p)->m_Value+1) == m_Decoration.m_Pack.GetCard(i)->m_Value)
						{
							CARD temp;
							temp.mast  = m_Decoration.m_Pack.GetCard(p)->m_Mast;
							temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
							temp.pos_value = m_Decoration.m_Pack.GetCard(p)->m_PosValue;
							m_GoCards.push_back(temp);
							break;
						}

			}// for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
		}// if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
	}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)

	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
			{
				if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
					if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
						if( m_Decoration.m_Pack.GetCard(p)->m_Mast  == m_Decoration.m_Pack.GetCard(i)->m_Mast &&
							 (m_Decoration.m_Pack.GetCard(p)->m_Value-1) == m_Decoration.m_Pack.GetCard(i)->m_Value)
						{
							CARD temp;
							temp.mast  = m_Decoration.m_Pack.GetCard(p)->m_Mast;
							temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
							temp.pos_value = m_Decoration.m_Pack.GetCard(p)->m_PosValue;
							m_GoCards.push_back(temp);
							break;
						}

			}// for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
		}// if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
	}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)


	//      
	//       
	for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
	{
		if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
				if(m_Decoration.m_Pack.GetCard(p)->m_Value == 4)
				{
					CARD temp;
					temp.mast = m_Decoration.m_Pack.GetCard(p)->m_Mast;
					temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
					temp.pos_value = m_Decoration.m_Pack.GetCard(p)->m_PosValue;
					m_GoCards.push_back(temp);
				}

	}// for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)

	return (m_GoCards.size() > 0);
}

//      
bool CChildView::IsEndCards(const int player)
{
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(i)->m_Player == player)
				return false;
	}

	return true;
}

//   
bool CChildView::IsEndParty(void)
{
	for(int p = 0; p < m_Decoration.m_NUMBERPLAYERS; p++)
	{
		if(m_Decoration.m_Player[p].GetMoney() <= 0)
		{
			// --          --

			//         ,
			//       ,  > 0 -  ,
			//  <= 0 -  
			if(m_GOINGPLAYER == (p+1))
				if( (m_Decoration.m_BankGame.GetMoney() + m_Decoration.m_Player[p].GetMoney()) > 0)
				{
					return false;
				}


			return true;
		}
	}

	return false;
}

//   
void CChildView::OnEndGame(void)
{
	//    
	if(IsEndParty() == false)
	{
		//    
		m_EnableNextGame = TRUE;

		m_Decoration.m_mainLabel.SetText("  " + m_Decoration.m_Player[m_GOINGPLAYER-1].GetName() + "!");
		m_Decoration.m_mainLabel.ShowText(true);

		//     -
		int number_victory = m_Decoration.m_Player[m_GOINGPLAYER-1].GetNumberVictory();
		number_victory++;
		m_Decoration.m_Player[m_GOINGPLAYER-1].SetNumberVictory(number_victory);
		
		//     -
		int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		int temp = bank_money;
		for(int i = 0; i < bank_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_BankGame.SetMoney(temp);
			m_Decoration.AnimMoneyToPlayer(m_GOINGPLAYER);
			player_money += 10;
			m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);
		}

		//   
		m_wndGameStatistics.SetStatistics(m_Decoration.m_Player, m_Decoration.m_NUMBERPLAYERS, m_NumberGames);
	}
	else
	{
		//       -
		int number_victory = m_Decoration.m_Player[m_GOINGPLAYER-1].GetNumberVictory();
		number_victory++;
		m_Decoration.m_Player[m_GOINGPLAYER-1].SetNumberVictory(number_victory);


		//    
		int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		int temp = bank_money;
		for(int i = 0; i < bank_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_BankGame.SetMoney(temp);
			m_Decoration.AnimMoneyToPlayer(m_GOINGPLAYER);
			player_money += 10;
			m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);
		}

		m_Decoration.m_mainLabel.SetText(" !!!");
		m_Decoration.m_mainLabel.ShowText(true);

		//      
		Sleep(500);
		m_wndGameStatistics.SetStatistics(m_Decoration.m_Player, m_Decoration.m_NUMBERPLAYERS, m_NumberGames);
		m_wndGameStatistics.Show(true);

		//    
		m_EnableNewParty = TRUE;
	}

}


//   OnSize
void CChildView::DoEvent_OnSize(void)
{
	CRect rc;
	GetClientRect(&rc);
	OnSize(0, rc.right, rc.bottom);
}


//   ,    
void CChildView::StopGame(void)
{
	m_StopProcess  = true;
	CCard::staticStopProcess     = true;
	CMoney::staticStopProcess    = true;
	CFinance::staticStopProcess	 = true;
}

//   
bool CChildView::IsStopGame(void)
{
	if(	CCard::staticCountProcess		== 0 &&
		m_CountProcess					== 0 && 
		CMoney::staticCountProcess		== 0 &&
		CFinance::staticCountProcess	== 0)
		return true;


		return false;
}

void CChildView::ContinueGame(void)
{
	m_StopProcess  = false;
	CCard::staticStopProcess    = false;
	CMoney::staticStopProcess   = false;
	CFinance::staticStopProcess	= false;
}



void CChildView::OnFileStatistics()
{
	//AfxBeginThread(TESTANIM, this);
		//return;

	m_wndGameStatistics.SetStatistics(m_Decoration.m_Player, m_Decoration.m_NUMBERPLAYERS, m_NumberGames);
	m_wndGameStatistics.Show(true);
}


//    
void CChildView::TestAnim(void)
{
	
	m_Decoration.m_Player[0].SetMoney(0);
	m_Decoration.m_Player[1].SetMoney(0);
	m_Decoration.m_Player[2].SetMoney(0);
	m_Decoration.m_Player[3].SetMoney(0);



	for(int p = 1; p <= 1; p++)
	{
		
		//m_Decoration.m_BankGame.SetMoney(50);
		m_Decoration.m_Player[p-1].SetMoney(1200);
		int player_money = m_Decoration.m_Player[p-1].GetMoney();
		int temp = player_money;	

		int bank_money = m_Decoration.m_BankGame.GetMoney();
		
		
		for(int i = 0; i < player_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_Player[p-1].SetMoney(temp);
			bank_money += 10;
			m_Decoration.AnimMoneyToBank(p);
			m_Decoration.m_BankGame.SetMoney(bank_money);
		}
	}

	return;

	for(int p = 1; p <= 4; p++)
	{
		
		int player_money = m_Decoration.m_Player[p-1].GetMoney();
		m_Decoration.m_BankGame.SetMoney(580);
			
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		int temp = bank_money;
		
		for(int i = 0; i < bank_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_BankGame.SetMoney(temp);
			m_Decoration.AnimMoneyToPlayer(p);
			player_money += 10;
			m_Decoration.m_Player[p-1].SetMoney(player_money);
			//Sleep(100);
		}
	}
	return;
	 
}


//        
LRESULT CChildView::OnPublicSetting(WPARAM wParam, LPARAM lParam)
{
	m_Decoration.OnPublicSetting(wParam, lParam);

	return LRESULT();
}

//    
void CChildView::ReadSettingFromReg(void)
{
	HKEY hkey;

	//      (APP_REGKEY_PUBLIC)
	//        
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		
		
		m_Decoration.ReadSettingFromReg(hkey);

		BOOL is_difficult;
		Util_ReadBoolRegKey(hkey, TEXT("DifficultGame"), &is_difficult, FALSE);
		m_Decoration.m_DifficultGame = BOOLTobool(is_difficult);
		if(is_difficult == true)
			m_Decoration.m_pAdjustment->m_PagePublicSetting.SetCheckButtons(CPagePublicSetting::chbDifficulty);

		Util_ReadIntRegKey(hkey, TEXT("RateGame"), (DWORD*)&m_Decoration.m_RateGame, 750);
		m_Decoration.m_pAdjustment->m_PagePublicSetting.SetSliderRate(1500 - m_Decoration.m_RateGame);
		

		//    
		TCHAR name_compplayers[12];
		Util_ReadStringRegKeyCch( hkey, TEXT("NameComp1"), name_compplayers, 12, "");
		m_Decoration.m_Player[1].SetName(name_compplayers);
		Util_ReadStringRegKeyCch( hkey, TEXT("NameComp2"), name_compplayers, 12, "");
		m_Decoration.m_Player[2].SetName(name_compplayers);
		Util_ReadStringRegKeyCch( hkey, TEXT("NameComp3"), name_compplayers, 12, "");
		m_Decoration.m_Player[3].SetName(name_compplayers);

        RegCloseKey( hkey );
    }
}

//      
void CChildView::WriteSettingToReg(void)
{
	HKEY hkey;

	//      (APP_REGKEY_PUBLIC)
	//        
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		m_Decoration.WriteSettingToReg(hkey);

		Util_WriteBoolRegKey(hkey, TEXT("DifficultGame"), boolToBOOL(m_Decoration.m_DifficultGame));
		Util_WriteIntRegKey(hkey, TEXT("RateGame"), m_Decoration.m_RateGame);


		//    
		Util_WriteStringRegKey( hkey, TEXT("NameComp1"), m_Decoration.m_Player[1].GetName().GetBuffer());
		Util_WriteStringRegKey( hkey, TEXT("NameComp2"), m_Decoration.m_Player[2].GetName().GetBuffer());
		Util_WriteStringRegKey( hkey, TEXT("NameComp3"), m_Decoration.m_Player[3].GetName().GetBuffer());

        RegCloseKey( hkey );
    }
}

//   
void CChildView::OnFileSetplayersnames()
{
	//      
	//      
	m_Decoration.SetPlayersName();

	//    
	m_Decoration.m_Player[1].SetName(m_Decoration.m_dlgUserName.m_strNameLeft);
	m_Decoration.m_Player[2].SetName(m_Decoration.m_dlgUserName.m_strNameTop);
	m_Decoration.m_Player[3].SetName(m_Decoration.m_dlgUserName.m_strNameRight);
}



void CChildView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{

	/*
	//      ,
	//    
	CCustomMenu menu;
	menu.CreatePopupMenu();
	menu.AppendMenu(ID_FILE_NEWPARTY, " ", RGB(0, 0, 255));

	if(m_EnableNextGame == TRUE)
		menu.AppendMenu(ID_FILE_NEXTGAME, " ", RGB(255,0,0));
	else
		menu.AppendMenu(ID_FILE_NEXTGAME, " ", GetSysColor(COLOR_GRAYTEXT), false);

	menu.AppendSeparator();
	menu.AppendMenu(ID_SETTING, "", RGB(0, 0, 0));
	menu.AppendMenu(ID_FILE_SETPLAYERSNAMES, "", RGB(0, 0, 0));
	menu.AppendMenu(ID_FILE_STATISTICS, "", RGB(0, 0, 0));
	menu.AppendMenu(ID_HELP_FINDER, "", RGB(0, 0, 0));
	
	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	*/

	//      ,
	//    
	CMenu menu;
	menu.CreatePopupMenu();

	if(m_EnableNextGame == TRUE)
		menu.AppendMenu(MF_STRING, ID_FILE_NEXTGAME, " ");
	else
		menu.AppendMenu(MF_GRAYED|MF_STRING, ID_FILE_NEXTGAME, " ");

	menu.AppendMenu(MF_STRING, ID_FILE_NEWPARTY, " ");

	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING, ID_FILE_SETPLAYERSNAMES, "");
	menu.AppendMenu(MF_STRING, ID_SETTING, "");
	
	menu.AppendMenu(MF_STRING, ID_FILE_STATISTICS, "");
	menu.AppendMenu(MF_STRING, ID_HELP_FINDER, "");
	
	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	//  F2   
	if(nChar == VK_F2)
		OnFileNewparty();

	//  F3   
	if(nChar == VK_F3)
	{
		OnFileStatistics();
	}

	if(nChar == VK_F1)
	{
		OnHelpApp();
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

//   
void CChildView::OnSetting()
{
	if(m_Decoration.m_pAdjustment != NULL)
		m_Decoration.m_pAdjustment->ShowWindow(SW_SHOW);
}


//   
void CChildView::OnHelpApp(void)
{
	m_Decoration.HelpApp();
}
