// InfoTablo.cpp : implementation file
//

#include "stdafx.h"
#include "NineKNet1.h"
#include "ChatTablo.h"
#include ".\chattablo.h"


// CChatTablo

IMPLEMENT_DYNAMIC(CChatTablo, CWnd)
CChatTablo::CChatTablo()
: m_sizeChatTablo(1)
{
	m_Rect.SetRectEmpty();
	m_Name[0] = "";
	m_Name[1] = "";
	m_Name[2] = "";
}

CChatTablo::~CChatTablo()
{
	Util_DeleteGdiObject(&m_Font);
}


BEGIN_MESSAGE_MAP(CChatTablo, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CChatTablo message handlers
void CChatTablo::InitChatTablo(CWnd* pParent, bool visible)
{
	if(visible == true)
		Create(NULL, NULL, WS_VISIBLE|WS_CHILD, m_Rect, pParent, 10);
	else
		Create(NULL, NULL, WS_CHILD, m_Rect, pParent, 10);


	m_CustomEdit.CreateMyEdit(CRect(5, 50, m_Rect.Width()-5, 70), this);
	m_CustomEdit.SetLimitText(28);
	m_CustomEdit.ModifyStyle(0, WS_BORDER);
	m_CustomEdit.m_pwndReceive = pParent;

	//SetColorText(RGB(255,255,255));
	m_CustomEdit.SetColorBG(RGB(210, 240, 210));
}


//     
void CChatTablo::SetChatTabloPos(int x, int y)
{
	SetWindowPos(NULL, x, y, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
}

void CChatTablo::OnPaint()
{
	CPaintDC dc(this); //device context for painting
	CBrush brush(RGB(0,80,0));
	dc.SelectObject(&brush);
	CPen pen(0, 1, RGB(255,255,255));
	dc.SelectObject(&pen);
	dc.Rectangle(&m_Rect);

	dc.SetBkMode(TRANSPARENT);
	COLORREF def_color = dc.SetTextColor(RGB(255,255,100));
	CFont* pdefFont = dc.SelectObject(&m_Font);
	int x_name  = 4;
	int cx_name;

	switch(m_sizeChatTablo)
	{
	case 1:
		cx_name = 45;
		break;
	case 2:
		cx_name = 70;
		break;
	case 3:
		cx_name = 80;
		break;
	}

	
	m_rcName[0].SetRect(x_name, 0, cx_name, m_Bottom[0]); //20
	dc.DrawText(m_Name[0], m_rcName[0], DT_SINGLELINE);
	
	m_rcName[1].SetRect(x_name, 15, cx_name, m_Bottom[1]); //35
	dc.DrawText(m_Name[1], m_rcName[1], DT_SINGLELINE);

	m_rcName[2].SetRect(x_name, 30, cx_name, m_Bottom[2]); // 50
	dc.DrawText(m_Name[2], m_rcName[2], DT_SINGLELINE);

	dc.SetTextColor(RGB(255,255,255));
	
	m_rcText[0].SetRect(cx_name+2, 0, m_Rect.Width(), m_Bottom[0]);
	dc.DrawText(m_TextMessage[0], m_rcText[0], DT_SINGLELINE);

	m_rcText[1].SetRect(cx_name+2,15, m_Rect.Width(), m_Bottom[1]);
	dc.DrawText(m_TextMessage[1], m_rcText[1], DT_SINGLELINE);

	m_rcText[2].SetRect(cx_name+2,30, m_Rect.Width(), m_Bottom[2]);
	dc.DrawText(m_TextMessage[2], m_rcText[2], DT_SINGLELINE);



	dc.SelectObject(pdefFont);
	dc.SetTextColor(def_color);
	
	// Do not call CWnd::OnPaint() for painting messages
	//CWnd::OnPaint();
}

//          
void CChatTablo::SizeChatTablo(int size_chattablo, const int& number_players)
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();

	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT)); // 

	int add;
	int center;
	int diff;

	switch(size_chattablo)
	{
	case 1:
		{
			lf.lfHeight = -10; 
			m_Rect.right = 205;
			m_Rect.bottom = 96;
			add = 60;
			center = 30;
			diff = (m_Rect.Width() - add*2 - 20*2 - center)/2;
		}
		break;
	case 2:
		{
			lf.lfHeight = -12;
			m_Rect.right = 265;
			add = 70;
			center = 40;
			diff = (m_Rect.Width() - add*2 - 20*2 - center)/2;
		}
		break;
	case 3:
		{
			lf.lfHeight = -14;
			m_Rect.right = 320;
			add = 80;
			center = 70;
			diff = (m_Rect.Width() - add*2 - 20*2 - center)/2;
		}
		break;
	}

	lf.lfWeight = FW_MEDIUM;
	lf.lfCharSet = RUSSIAN_CHARSET;
	strcpy(lf.lfFaceName, "Microsoft Sans Serif");
	m_Font.CreateFontIndirect(&lf);

	m_CustomEdit.SetMyEditFont(&lf);
	

	SetNumberPlayers(number_players);

	if(m_Bottom[1] == 0)
		m_CustomEdit.SetWindowPos(NULL, 5, m_Bottom[0], m_Rect.Width() - 10, 20, SWP_NOZORDER);
	else if(m_Bottom[2] == 0)
		m_CustomEdit.SetWindowPos(NULL, 5, m_Bottom[1], m_Rect.Width() - 10, 20, SWP_NOZORDER);
	else 
		m_CustomEdit.SetWindowPos(NULL, 5, m_Bottom[2], m_Rect.Width() - 10, 20, SWP_NOZORDER);

	m_sizeChatTablo = size_chattablo;	
}

//   
void CChatTablo::SetName(const int& player, const CString& name_player)
{
	m_Name[player-1] = name_player;
	InvalidateRect(m_rcName[player-1]);
}

//        
void CChatTablo::SetText(const int& player, const CString& text_message)
{
	m_TextMessage[player-1] = text_message;
	InvalidateRect(m_rcText[player-1]);
}


//       
void CChatTablo::SetNumberPlayers(const int& number_players)
{
	switch(number_players)
	{
	case 1:
		m_Rect.bottom = 0;
		m_Bottom[0] = 0;
		m_Bottom[1] = 0;
		m_Bottom[2] = 0;
		break;
	case 2:
		m_Rect.bottom = 45;
		m_Bottom[0] = 20;
		m_Bottom[1] = 0;
		m_Bottom[2] = 0;
		break;
	case 3:
		m_Rect.bottom = 60;
		m_Bottom[0] = 20;
		m_Bottom[1] = 35;
		m_Bottom[2] = 0;
		break;
	case 4:
		m_Rect.bottom = 73;
		m_Bottom[0] = 20;
		m_Bottom[1] = 35;
		m_Bottom[2] = 50;
		break;
	default:
		m_Rect.bottom = 0;
		m_Bottom[0] = 0;
		m_Bottom[1] = 0;
		m_Bottom[2] = 0;
		break;
	}

	SetWindowPos(NULL, 0, 0, m_Rect.Width(), m_Rect.Height(), SWP_NOMOVE|SWP_NOZORDER);
}



void CChatTablo::ShowChat(bool show)
{
	//      
	//   .
	if(m_hWnd == 0) return;

	int Flag;
	show == true ? Flag = SW_SHOW : Flag = SW_HIDE;
	this->ShowWindow(Flag);
}
