#pragma once

#include <initguid.h> //      #include <dplay8.h>
#include <dplay8.h>
#include "ipcompinfo.h"
#include "NineKNet1.h"
#include "player.h"
#include "connectdlg.h"
#include "afxmt.h"


///////////////////////////////////////////////////////////////////////////////
//      
///////////////////////////////////////////////////////////////////////////////

//          ,
//         
//       
struct MSG_TYPE
{
	MSG_TYPE(){msg_type = 0;}
	char msg_type;
};

struct INITNEWPARTY : MSG_TYPE
{
	INITNEWPARTY() {number_money = 0;}
	int number_money;
};

//     
struct ID_PLAYER : MSG_TYPE
{
	DWORD id_player;
};

//    
struct PLAYERS_CHAT : ID_PLAYER
{
	PLAYERS_CHAT(){size_buffer = 30; ZeroMemory(chat_buffer, size_buffer*sizeof(TCHAR)); id_player = 0;}
	
	//       CMyEdit +  
	char size_buffer;
	TCHAR chat_buffer[30];
};

//         
struct DATA_DISTRCARDS : ID_PLAYER
{
	char mast[36];
	char value[36];
};

//   
struct PLAYERS_DATA : MSG_TYPE
{
	CDataPlayer data_player[4];
};

//         
//        
struct DATA_CARD : ID_PLAYER
{
	DATA_CARD(){mast = 0; value = 0; id_player = 0; /*state = 0;*/ }
	char mast;
	char value;
	char state;
	
};

//       
struct NEWPLAYERS_DATA : PLAYERS_DATA
{
	NEWPLAYERS_DATA() {number_games = 0; bank_money = 0;}
	int number_games;
	int bank_money;
	DATA_CARD data_card[36];
};


//      
//     
struct HOSTINFO
{
	HOSTINFO(){pHostAddress = NULL; pAppDesc = NULL;}
    IDirectPlay8Address*    pHostAddress;
	DPN_APPLICATION_DESC*   pAppDesc;
	
};

HRESULT WINAPI DPMessageHandler( PVOID pvUserContext, DWORD dwMessageId, PVOID pMsgBuffer);

const int MAXNUMBERPORT   = 2309;  // 8      .
const int BEGINNUMBERPORT = 2301;

class CDirectPlay
{
public:
	CDirectPlay(void);
	~CDirectPlay(void);

	//  .
	enum {	msgRequestIdle=1, 
			msgReplyIdle, 
			msgInitPlayers,
			msgInitNewPlayers,
			msgDataNewPlayers,
			msgReInitPlayers,
			msgNewParty, 
			msgNextGame, 
			msgDistrCards, 
			msgGoPlayer, 
			msgGoCard, 
			msgRollingPlayer,
			msgPlayersChat,
			msgStopProcess
	};

	//   .
	enum {modeIndefinitely, modeHost, modeClient} m_Mode;
	
	HRESULT SetPeerInfo(DPN_PLAYER_INFO* const player_info);
	HRESULT GetPeerInfo(DPNID id_player, DPN_PLAYER_INFO** player_info);
	HRESULT SetPlayerInfo(CDataPlayer* const player_data);
	HRESULT GetPlayerInfo(DPNID id_player, CDataPlayer* player_data);
	HRESULT SetPlayerName(TCHAR* szPlayerName);
	//     
	HRESULT GetCurrentPLayers(DWORD* number_players);
	HRESULT GetMaxPlayers(DWORD* dwMaxPlayers);
	//     
	HRESULT OnEnumHostComplete(void/*BOOL autoconnect*/);
	//    
	HRESULT SendToGroup(void* send_data, const DWORD& size_data, bool noloopback);
	//    
	HRESULT SendToPlayer(DPNID id_player, void* send_data, const DWORD& size_data, bool noloopback=true);
	//          
	void DoNetwork(void);
	//   
	HRESULT Disconnect(void);

	//     , 
	//            
	void OnConnectComplete(HRESULT return_connect);
	HRESULT ReInitDirectPlay(void);
	HRESULT InitDirectPlay(void);
	void AutoCreateHost(void);

	std::vector<HOSTINFO*> m_vecHostInfo;
	//     
	DPNHANDLE m_hAsyngEnumHosts;
	//      
	DPNHANDLE m_hAsyngConnect;
	CWnd* m_pParent;
	//     
	DPNID m_IDPlayer;
	//  () 
	DPNID m_IDLocalPlayer;
	
	// --         --
	CCriticalSection m_criticalEnumHosts;
	CCriticalSection m_criticalAsyngOpComplete;
	CCriticalSection m_criticalIndicateConnect;
	CCriticalSection m_criticalCreatePlayer;
	
	CCriticalSection m_criticalDestroyPlayer;
	CCriticalSection m_criticalPeerInfo;
	CCriticalSection m_criticalReceive;
	CCriticalSection m_criticalHostMigrate;
	CCriticalSection m_criticalConnectComplete;


	DWORD m_NumberPort;
private:

	HRESULT CreateDeviceAddress(DWORD port, IDirectPlay8Address**  ppDeviceAddress, CString address);
	//  - 
	HRESULT CreateHost(void);
	//   
	HRESULT DoConnect(IDirectPlay8Address*  pHostAddress, DPN_APPLICATION_DESC*  dpnAppDesc);
	HRESULT CreateHostAddress(IDirectPlay8Address** ppHostAddress, TCHAR* szAddress, DWORD dwRemotePort);
	//   
	HRESULT ConnectToHost(void);
	//        
	HRESULT GetHostAddressesPort(void);
	//  IP-      IDirectPlay8Address
	HRESULT GetAddressPort(IDirectPlay8Address* const prgpAddress, TCHAR* ip_address, DWORD* number_port=NULL);

	IDirectPlay8Peer* m_pDP;
	//       
	CString m_strAddress;
	
	//   
	CConnectDlg m_ConnectDlg;
	CIPCompInfo m_IPCompInfo;
	
public:
	//   .
	bool m_StopProccess;
};
