// GameStatistics.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "GameStatistics.h"
#include ".\gamestatistics.h"
#include "vector"
#include "algorithm"


// CGameStatistics

IMPLEMENT_DYNAMIC(CGameStatistics, CWnd)
CGameStatistics::CGameStatistics()
: m_NumberGames(0)
, m_NumberPlayers(0)
{
}

CGameStatistics::~CGameStatistics()
{
}


BEGIN_MESSAGE_MAP(CGameStatistics, CWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()



// CGameStatistics message handlers


BOOL CGameStatistics::PreCreateWindow(CREATESTRUCT& cs)
{
	HBRUSH brush = CreateSolidBrush(RGB(50, 100, 50)); //RGB(104, 133, 50) //CreateSolidBrush(RGB(148, 96, 56));// CreateSolidBrush(RGB(80,30,0));
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), brush, NULL);

	return CWnd::PreCreateWindow(cs);
}

//     
void CGameStatistics::SetWndPos(const int& x, const int& y, bool center)
{
	CRect rc;
	GetClientRect(&rc);
	if(center == true)
		SetWindowPos(NULL, x - rc.right/2, y - rc.bottom/2, 0,0, SWP_NOZORDER|SWP_NOSIZE);
	else
		SetWindowPos(NULL, x, y, 0,0, SWP_NOZORDER|SWP_NOSIZE);
}

//   
BOOL CGameStatistics::InitWnd(CWnd* pParent)
{
	CRect RC;
	RC.SetRect(0, 0, 500, 250);
	BOOL result = Create(NULL, NULL, WS_CHILD, RC, pParent, 15);

	m_Rect.left   = RC.Width()/2 - 70/2;
	m_Rect.right  = m_Rect.left + 70;
	m_Rect.top    = RC.bottom  - (25 + 10);
	m_Rect.bottom = m_Rect.top  + 25;

	return result;
}

void CGameStatistics::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	CRect rc;
	GetClientRect(&rc);
	CBrush brush(RGB(255,255,255));
	dc.FrameRect(&rc, &brush);


	dc.SetBkMode(TRANSPARENT);
	dc.SetTextColor(RGB(255,255,255));
	CFont font_line;
	font_line.CreatePointFont(180, "Times New Roman");
	CFont* pOldFont = dc.SelectObject(&font_line);
	dc.DrawText(" ", &rc, DT_CENTER);
	dc.SelectObject(pOldFont);

	ShowTable(&dc);

	CBitmap bmp;
	bmp.LoadBitmap(IDB_BUTTON);
	
	dc.DrawState(m_Rect.TopLeft(), CSize(70, 25), &bmp, DST_BITMAP);

	// Do not call CWnd::OnPaint() for painting messages
}


//    
void CGameStatistics::ShowTable(CDC* pDC)
{
	CPen pen(0, 1, RGB(255,255,255));
	pDC->SelectObject(&pen);

	CFont font_line;
	font_line.CreatePointFont(140, "Times New Roman");
	CFont* pOldFont = pDC->SelectObject(&font_line);

	CRect rc;
	GetClientRect(&rc);
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(RGB(255,255,255));
	int length = rc.right;

	//    
	CString player_name = "    ";
	CSize size_player_name = pDC->GetTextExtent(player_name);
	CSize size_prize = pDC->GetTextExtent("  ");
	CSize size_number_win  = pDC->GetTextExtent("   ");
	CSize size_number_roll = pDC->GetTextExtent("  ");
	CSize size_money = pDC->GetTextExtent("   ");

	int width_table = size_player_name.cx + size_prize.cx + size_number_win.cx + size_number_roll.cx + size_money.cx;


	//    ,      
	int add = (rc.Width() - width_table + 4)/2;
	int top = 30;
	
	//    
	rc.top = top;
	pDC->MoveTo(rc.left + 9, rc.top);
	pDC->LineTo(rc.left + 9 + width_table, rc.top);

	//   
	rc.top = top;
	m_WC[0].left  = rc.left = add;
	m_WC[0].right = rc.right = add + size_prize.cx;
	pDC->DrawText(" \n", &rc, DT_CENTER);

	//    
	rc.top = top + size_prize.cy*2 + 4;
	pDC->MoveTo(rc.left - 2, rc.top - 2);
	pDC->LineTo(rc.left + width_table, rc.top - 2);

	//   
	rc.top = top;
	m_WC[1].left  = rc.left = add + size_prize.cx;
	m_WC[1].right = rc.right = add + size_prize.cx + size_player_name.cx;
	pDC->DrawText(" \n", &rc, DT_CENTER);
	
	//   
	m_WC[2].left  = rc.left = add + size_player_name.cx + size_prize.cx;
	m_WC[2].right = rc.right = add + size_prize.cx + size_player_name.cx + size_number_win.cx;
	pDC->DrawText(" \n ", &rc, DT_CENTER);
	
	//   
	m_WC[3].left  = rc.left = add + size_player_name.cx + size_prize.cx + size_number_win.cx;
	m_WC[3].right = rc.right = add + size_prize.cx + size_player_name.cx + size_number_win.cx + size_number_roll.cx;
	pDC->DrawText(" \n", &rc, DT_CENTER);
	
	//   
	m_WC[4].left = rc.left = add + size_player_name.cx + size_prize.cx + size_number_win.cx + size_number_roll.cx;
	m_WC[4].right = rc.right = add + size_prize.cx + size_player_name.cx + size_number_win.cx + size_number_roll.cx + size_money.cx;
	pDC->DrawText(" \n ", &rc, DT_CENTER);

	
	//  
	GetClientRect(&rc);
	rc.left = add;
	rc.right = add + size_prize.cx;
	rc.top = top + size_prize.cy*2 + 10;

	int number_line = m_NumberPlayers; 
	for(int i = 0; i < number_line; i++)
		LineTable(pDC, (i + 1), rc.top);

	//   
	rc.top = 178; //top + size_prize.cy*2 + 4;
	pDC->MoveTo(rc.left - 2, rc.top - 2);
	pDC->LineTo(rc.left + width_table, rc.top - 2);

	//    
	COLORREF old_color_text = pDC->GetTextColor();
	pDC->SetTextColor(RGB(255, 255, 255));
	GetClientRect(&rc);
	rc.top = 178;
	rc.left = add;
	rc.right = rc.right;
	pDC->DrawText("   - " + IntToStr(m_NumberGames), &rc, DT_LEFT);
	pDC->SetTextColor(old_color_text);

	pDC->SelectObject(pOldFont);
	
}

//   .
void CGameStatistics::LineTable(CDC* pDC, const int& line_table, const int& first_top)
{
	
	//      .
	COLORREF text_color = 0;
	if(	m_PlayersStat[line_table - 1].prize == "")
		text_color = RGB(255, 255, 100);
	if(	m_PlayersStat[line_table - 1].prize == "")
		text_color = RGB(225, 225, 225);
	if(	m_PlayersStat[line_table - 1].prize == "")
		text_color = RGB(230, 110, 110);
	if(	m_PlayersStat[line_table - 1].prize == "")
		text_color = RGB(0, 0, 0);
	

	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(text_color);

	CRect rc;
	rc.top = first_top;
	//   
	int between = 22;
	rc.top = first_top + between*(line_table - 1);
	
	//  
	rc.left  = m_WC[0].left; 
	rc.right = m_WC[0].right; 
	CString str = m_PlayersStat[line_table - 1].prize;
	pDC->DrawText(str, &rc, DT_CENTER);

	//  
	rc.left  = rc.left  = m_WC[1].left; 
	rc.right = rc.right = m_WC[1].right; 
	pDC->DrawText(m_PlayersStat[line_table - 1].players_name, &rc, DT_CENTER);

	//  
	rc.left  = m_WC[2].left;
	rc.right = m_WC[2].right;
	str = IntToStr(m_PlayersStat[line_table - 1].number_victory);
	pDC->DrawText(str, &rc, DT_CENTER);

	//  
	rc.left  = m_WC[3].left;
	rc.right = m_WC[3].right;
	str = IntToStr(m_PlayersStat[line_table - 1].number_roll);
	pDC->DrawText(str, &rc, DT_CENTER);

	//  
	rc.left  = m_WC[4].left;
	rc.right = m_WC[4].right;
	str = IntToStr(m_PlayersStat[line_table - 1].players_money);
	str += "p.";
	pDC->DrawText(str, &rc, DT_CENTER);

}


//      ,
//      ,
//       .
bool SORTPRIZE(CPlayer* p1, CPlayer* p2)
{
	bool result;

	//    ,     
	int money1 = p1->GetMoney();
	int money2 = p2->GetMoney();

	// :
	//      ,
	//    ,     ,
	//    ,    (  ),
	//    ,     .
	if(money1 == money2)
	{
		int number_victory1 = p1->GetNumberVictory();
		int number_victory2 = p2->GetNumberVictory();

		if(number_victory1 == number_victory2)
		{
			int number_roll1 = p1->GetNumberRoll();
			int number_roll2 = p2->GetNumberRoll();

			result = number_roll1 < number_roll2;
		}
		else
		{
			result = number_victory1 > number_victory2;
		}
	}
	else
	{
		result = money1 > money2;
	}

	return result;
}

void CGameStatistics::SetStatistics(CPlayer players[4], const int& number_players, const int& number_games)
{
	m_NumberPlayers = number_players;
	m_NumberGames   = number_games;

	//     
	//    - .
	std::vector<CPlayer*> vecPlayers;
	for(int p = 0; p < number_players; p++)
		vecPlayers.push_back(&players[p]);

	std::stable_sort(vecPlayers.begin(), vecPlayers.end(), SORTPRIZE);

	for(int i = 0; i < number_players; i++)
	{
		m_PlayersStat[i].players_name  = vecPlayers[i]->GetName();
		m_PlayersStat[i].players_money = vecPlayers[i]->GetMoney();
		m_PlayersStat[i].number_victory = vecPlayers[i]->GetNumberVictory();
		m_PlayersStat[i].number_roll   = vecPlayers[i]->GetNumberRoll();
	}

	m_PlayersStat[0].prize = "";
	int max_money = m_PlayersStat[0].players_money;
	int max_victory = m_PlayersStat[0].number_victory;
	int max_roll  = m_PlayersStat[0].number_roll;

	
	//         
	int p1;
	for(p1 = 1; p1 < number_players; p1++)
	{
		if(	max_money == m_PlayersStat[p1].players_money &&
			max_victory   == m_PlayersStat[p1].number_victory    &&
			max_roll  == m_PlayersStat[p1].number_roll)
			m_PlayersStat[p1].prize = "";
		else
		{
			//     
			max_money = m_PlayersStat[p1].players_money;
			max_victory   = m_PlayersStat[p1].number_victory;
			max_roll  = m_PlayersStat[p1].number_roll;
			break;

		}// else if(	max_money ==
	}// for(p1 = 0; p1 < number_players; p1++)

	//      
	int p2;
	for(p2 = p1; p2 < number_players; p2++)
	{
		if(	max_money == m_PlayersStat[p2].players_money &&
			max_victory   == m_PlayersStat[p2].number_victory    &&
			max_roll  == m_PlayersStat[p2].number_roll)
			m_PlayersStat[p2].prize = "";
		else
		{
			//     
			max_money = m_PlayersStat[p2].players_money;
			max_victory   = m_PlayersStat[p2].number_victory;
			max_roll  = m_PlayersStat[p2].number_roll;
			break;

		}// else if(	max_money ==
	}// for(p1 = 0; p1 < number_players; p1++)

	//       
	int p3;
	for(p3 = p2; p3 < number_players; p3++)
	{
		if(	max_money == m_PlayersStat[p3].players_money &&
			max_victory   == m_PlayersStat[p3].number_victory    &&
			max_roll  == m_PlayersStat[p3].number_roll)
			m_PlayersStat[p3].prize = "";
		else
			break;

	}// for(p1 = 0; p1 < number_players; p1++)

	//       
	int p4;
	for(p4 = p3; p4 < number_players; p4++)
	{
		m_PlayersStat[p4].prize = "";
		
	}// for(p1 = 0; p1 < number_players; p1++)

	Invalidate();
}

void CGameStatistics::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(m_Rect.PtInRect(point) == TRUE)
		Show(false);

	CWnd::OnLButtonDown(nFlags, point);
}
