// MessageBox.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "MessageBox.h"
#include ".\messagebox.h"


// CMessageBox dialog

IMPLEMENT_DYNAMIC(CMessageBox, CDialog)
CMessageBox::CMessageBox(CWnd* pParent /*=NULL*/)
	: CDialog(IDD_DIALOG_MESSAGEBOX, pParent)
	, m_strText(_T(""))
	, m_strCaption(_T("!"))
	, m_Flags(0)
	, m_PsevdoBorder(10)
{
	
}

CMessageBox::~CMessageBox()
{
}

void CMessageBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_TEXT, m_wndText);
}


BEGIN_MESSAGE_MAP(CMessageBox, CDialog)
END_MESSAGE_MAP()


// CMessageBox message handlers

BOOL CMessageBox::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitMessageBox();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//     
CSize CMessageBox::GetSizeText(void)
{
	////////////////////////////////////////////////////////////////////////////////////////
	//   
	//     
	//    
	int count_line = 1;
	CString str_size;		//  
	CString str_size_max;	//   
	for(int i = 0; i < m_strText.GetLength(); i++)
	{
		if(m_strText[i] != '\n' && m_strText[i] != '\r')
			str_size += m_strText[i];

		if(m_strText[i] == '\n')
		{
			
			count_line++;
			//     
			if(str_size.GetLength() >= str_size_max.GetLength())
			{
				str_size_max = str_size;
			}

			str_size.Empty();
		}
	
	}// for(int i = 0; i < m_strText.GetLength(); i++)

	//   
	//    
	if(count_line == 1)
	{
		str_size_max = m_strText;
	}
	else
	{
		//   ,   
		if(str_size.GetLength() >= str_size_max.GetLength())
		{
			str_size_max = str_size;
		}
	}


	//       
	CSize sz_text;
	CDC* this_dc = GetDC();
	if(this_dc != NULL)
	{
		CFont* pOldFont = this_dc->SelectObject(this->GetFont());

		sz_text = this_dc->GetTextExtent( str_size_max);	//    

		this_dc->SelectObject(pOldFont);
		ReleaseDC(this_dc);
	}
	else
	{
		Beep(2000,100);
	}

	sz_text.cy *= count_line;

	return sz_text;
}

//      
CSize CMessageBox::GetBorder(void)
{
	CRect rc_wnd;
	CRect rc_client;
	GetWindowRect(&rc_wnd);
	GetClientRect(&rc_client);

	int height_caption = GetSystemMetrics(SM_CYCAPTION);
	CSize sz_border;
	sz_border.cx = (rc_wnd.Width()  - rc_client.Width())/2;
	sz_border.cy = ( (rc_wnd.Height() - rc_client.Height()) - height_caption)/2;

	return sz_border;
}

//     
CSize CMessageBox::GetSizeCaption(void)
{

	NONCLIENTMETRICS ncmetr;
	ncmetr.cbSize = sizeof(NONCLIENTMETRICS);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncmetr, 0);
	

	CString str_caption;
	GetWindowText(str_caption);
	CFont font;
	font.CreateFontIndirect(&ncmetr.lfCaptionFont);

	int width_icon_caption = GetSystemMetrics(SM_CXSMICON);

	CSize sz_caption;
	CDC* this_dc = GetDC();
	if(this_dc != NULL)
	{
		CFont* pOldFont = this_dc->SelectObject(&font);
		sz_caption = this_dc->GetOutputTextExtent( str_caption + "W");	//    

		this_dc->SelectObject(pOldFont);
		ReleaseDC(this_dc);
	}
	else
	{
		Beep(2000,100);
	}


	return sz_caption;
}

void CMessageBox::InitMessageBox(void)
{
	//  
	SetWindowText(m_strCaption);

	//    
	//  :   +  +   +  +  
	//  :    +  +   +  +   +  +  
	int width_wnd = 0;

	int border = m_PsevdoBorder; //   
	int width_icon  = 32; //  
	int height_icon = 32; //  
	//  
	CSize sz_text = GetSizeText();
	CSize sz_caption= GetSizeCaption();
	int width_border_wnd  = GetBorder().cx;
	
	if(sz_text.cx > sz_caption.cx)
		width_wnd = width_border_wnd + border + width_icon + border + sz_text.cx + border + width_border_wnd;
	else
		width_wnd = width_border_wnd + border + width_icon + border + sz_caption.cx + border + width_border_wnd;
	

	//     
	if(width_wnd < 90) width_wnd = 90;


	//  
	CRect rc_button_ok;
	CRect rc_button_cancel;
	GetDlgItem(IDOK)->GetWindowRect(&rc_button_ok);
	GetDlgItem(IDCANCEL)->GetWindowRect(&rc_button_cancel);

	int space = 2; //   
	if((m_Flags & MMB_OKCANCEL) == MMB_OKCANCEL || (m_Flags & MMB_YESNO) == MMB_YESNO)
	{
		//         
		int width_with_buttons = width_border_wnd + border + rc_button_ok.Width() +
			space*2 + rc_button_cancel.Width() + border + width_border_wnd;

		//     ,     
		//          
		if(width_wnd < width_with_buttons) width_wnd = width_with_buttons;
	}


	//   
	//  :   +   +  +   +  +  
	//  :   +   +  +   +  +   +  +  
	int height_wnd = 0;

	
	int height_button = rc_button_ok.Height();

	int height_caption = GetSystemMetrics(SM_CYCAPTION);
	int height_border_wnd  = GetBorder().cy;

	
	//     
	if((m_Flags & MMB_OK) != MMB_OK && (m_Flags & MMB_OKCANCEL) != MMB_OKCANCEL && (m_Flags & MMB_YESNO) != MMB_YESNO)
	{
		height_wnd = height_caption + height_border_wnd + border + sz_text.cy + border + height_border_wnd;

		int height_with_icon = height_caption + height_border_wnd + border + 
											height_icon + border + height_border_wnd;

		//     
		if(height_wnd < height_with_icon) height_wnd = height_with_icon;
	}
	else 
	{
		//     
		height_wnd = height_caption + height_border_wnd + border + 
							sz_text.cy + border + height_button + border + height_border_wnd;

		int height_with_icon = height_caption + height_border_wnd + border + 
											height_icon + border + height_button + border + height_border_wnd;

		//       
		if(height_wnd < height_with_icon) height_wnd = height_with_icon;
	}

	//CalcWindowRect -         
	
	SetWindowPos(NULL, 0, 0, width_wnd, 
							 height_wnd, 
							 SWP_NOZORDER|SWP_NOMOVE);

	//   
	//  :    ,    
	//  :  +   + 
	int left = width_wnd/2 - sz_text.cx/2;
	int top  = border;

	
	left = width_icon + border*2;
	top  = border;


	m_wndText.SetWindowPos(NULL, left, top, 
							sz_text.cx, 
							sz_text.cy, 
							SWP_NOZORDER);
	//  
	m_wndText.SetWindowText(m_strText);

	

	//     
	//     
	CRect rc_client;
	GetClientRect(&rc_client);

	//  
	/////////////////////////////////////////////////////////////////////////////
	//    
	int bottom_button = 12;
	if((m_Flags & MMB_OK) == MMB_OK /*&& (m_Flags & MMB_OKCANCEL) != MMB_OKCANCEL*/)
	{
		GetDlgItem(IDOK)->SetWindowPos(NULL, rc_client.Width()/2 - rc_button_ok.Width()/2, 
			rc_client.bottom - border - rc_button_ok.Height(), 
			rc_button_ok.Width(), rc_button_ok.Height(),  SWP_NOZORDER);

		
		GetDlgItem(IDOK)->ShowWindow(SW_SHOW);
		GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
	}
	else //if((m_Flags & MMB_OKCANCEL) == MMB_OKCANCEL)
	{
		GetDlgItem(IDOK)->SetWindowPos(NULL, rc_client.Width()/2 - rc_button_ok.Width() - space, 
			rc_client.bottom - border - rc_button_ok.Height(), 
			rc_button_ok.Width(), rc_button_ok.Height(),  SWP_NOZORDER);

		GetDlgItem(IDCANCEL)->SetWindowPos(NULL, rc_client.Width()/2 + space, 
			rc_client.bottom - border - rc_button_cancel.Height(), 
			rc_button_cancel.Width(), rc_button_cancel.Height(),  SWP_NOZORDER);


		if((m_Flags & MMB_YESNO) == MMB_YESNO)
		{
			GetDlgItem(IDOK)->SetWindowText("");
			GetDlgItem(IDCANCEL)->SetWindowText("");
		}

		GetDlgItem(IDOK)->ShowWindow(SW_SHOW);
		GetDlgItem(IDCANCEL)->ShowWindow(SW_SHOW);
	}
}
