#include "StdAfx.h"
#include "Pack.h"
#include ".\pack.h"
//#include "MessageBox.h"


// CCard

//   
//        
//        
bool CCard::staticStopProcess = false;
int  CCard::staticCountProcess = 0;
bool CCard::staticSound = true;


IMPLEMENT_DYNAMIC(CCard, CWnd)
CCard::CCard()
: m_bMove(false)
, m_X(0)
, m_Y(0)
, m_bIsFace(false)
, m_Value(0)
, m_Mast(0)
, m_Player(0)
, m_State(0)
, m_bOpenningCard(false)
, m_bAnimCards(true) //         
, m_PosValue(0)
{

}


CCard::CCard(const CCard& copy)
{
	
}


CCard::~CCard()
{

	Util_DeleteGdiObject((CGdiObject*)&m_bmpFace);
	Util_DeleteGdiObject((CGdiObject*)&m_bmpShirt);
}


BEGIN_MESSAGE_MAP(CCard, CWnd)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()



// CCard message handlers


BOOL CCard::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Add your specialized code here and/or call the base class
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW, 
		::LoadCursor(NULL, IDC_ARROW), NULL, NULL);
	
	return TRUE;
}

void CCard::OnLButtonDown(UINT nFlags, CPoint point)
{
	CWnd* pParent = GetParent();
	if(pParent != NULL)
		pParent->SendMessage(WM_CARDLBUTTONDOWN,(WPARAM)this);
	
	CWnd::OnLButtonDown(nFlags, point);
}

BOOL __fastcall CCard::CreateCard(CRect rc, CWnd* parent, UINT ID_FACE, UINT ID_SHIRT)
{
	BOOL result = FALSE;
	result = Create("", "", WS_VISIBLE|WS_CLIPSIBLINGS, rc, parent, 0);

	CRgn Rgn;
	Rgn.CreateRoundRectRgn(0, 0, CARDWIDTH+1, CARDHEIGHT+1, 4, 4);
	SetWindowRgn(Rgn, TRUE);


	SetBmp(ID_FACE, ID_SHIRT);
	
	return result;
}

void __fastcall CCard::SetBmp(UINT ID_FACE, UINT ID_SHIRT)
{
	if(ID_FACE != 0){
		if(m_bmpFace.m_hObject != NULL)
			m_bmpFace.DeleteObject();
		m_bmpFace.LoadBitmap(ID_FACE);
	}
	if(ID_SHIRT != 0){
		if(m_bmpShirt.m_hObject != NULL)
			m_bmpShirt.DeleteObject();
		m_bmpShirt.LoadBitmap(ID_SHIRT);
	}
}


//     .
void CCard::CardMoveSound(int left, int top, int mode_sound)
{
	CardMove(left, top, false);

	if(staticSound == true)
	{
		if(mode_sound == 1)
			PlaySound( MAKEINTRESOURCE(IDR_WAVE_CARD), AfxGetApp()->m_hInstance, SND_RESOURCE | SND_ASYNC);
		else if(mode_sound == 2)
			PlaySound( MAKEINTRESOURCE(IDR_WAVE_ROLL), AfxGetApp()->m_hInstance, SND_RESOURCE | SND_ASYNC);
	}
}

//          .
void __fastcall CCard::CardMove(int left, int top, bool quickspeed)
{
	staticCountProcess++;

	if(m_bAnimCards == false || staticStopProcess == true)
	{
		SetCardPos(left, top);
		staticCountProcess--;
		return;
	}


	HANDLE g_h = CreateEvent(0, true, false, "1");

	CPoint pt = GetCardPos();
	int y_offset = pt.y - top;
	int x_offset = left - pt.x;

	//   
	int max_offset = max( (y_offset > 0 ? y_offset : y_offset*-1),  (x_offset > 0 ? x_offset : x_offset*-1) );

	int speed = 8;
	if(quickspeed == true)
		speed = 3;

	int step_y = y_offset/speed;
	int step_x = x_offset/speed;

	for (int coor = 1; coor < (speed-1); coor++)
	{
		if(m_bAnimCards == false || staticStopProcess == true)
		{
			coor = speed-1;
			break;
		}

		pt.y -= step_y;
		pt.x += step_x;
		SetCardPos(pt);

		//
		WaitForSingleObject(g_h, 8);
	}
		
	pt.x = left;
	pt.y = top;
	SetCardPos(pt);


	staticCountProcess--;
}

CPoint CCard::GetCardPos(void)
{
	//     
	//    
	CPoint result;
	result.x = 0;

	CWnd* pWnd = GetParent();
	if(pWnd != NULL)
	{
		CRect rcChild, rcParent;
		pWnd->GetClientRect(&rcParent);
		GetClientRect(&rcChild);
		ClientToScreen(&rcChild);
		pWnd->ClientToScreen(&rcParent);
		result.x = rcChild.left - rcParent.left;
		result.y = rcChild.top  - rcParent.top;
	}
	
	
	return result;
}

void CCard::SetCardPos(const CPoint& ptPos)
{
	SetCardPos(ptPos.x, ptPos.y);
}

void __fastcall CCard::SetCardPos(const int& x, const int& y)
{
	HDWP hdwp = BeginDeferWindowPos(1);
	DeferWindowPos(hdwp, this->m_hWnd, HWND_TOP, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	EndDeferWindowPos(hdwp);
}

BOOL CCard::OnEraseBkgnd(CDC* pDC)
{
	CRect rc;
	GetClientRect(&rc);

	CBitmap m_BitmapCompatible;
	CDC m_MemDC;

	m_MemDC.CreateCompatibleDC(pDC);
	m_BitmapCompatible.CreateCompatibleBitmap(pDC, CARDWIDTH, CARDHEIGHT);

	//pDC->SaveDC();
	
	if(m_bOpenningCard == true || m_bIsFace == true){
		CBitmap *oldBitmap;
		oldBitmap = m_MemDC.SelectObject(&m_BitmapCompatible);
		m_MemDC.DrawState(CPoint(0, 0), CSize(CARDWIDTH, CARDHEIGHT), m_bmpFace, DST_BITMAP); 
		pDC->StretchBlt(0, 0, rc.Width(), rc.Height(), &m_MemDC, 0, 0, CARDWIDTH, CARDHEIGHT, SRCCOPY);
		m_MemDC.SelectObject(oldBitmap);
	}
	else{
		if(DrawImage( pDC->GetSafeHdc(), CRect(0,0, rc.Width(), rc.Height()))== S_OK){
			pDC->Draw3dRect(CRect(0,0, rc.Width(), rc.Height()), RGB(0,0,0), RGB(0,0,0));
			pDC->Draw3dRect(CRect(1,1, rc.Width()-1, rc.Height()-1), RGB(255,255,255), RGB(255,255,255));
			CPen pen(0, 1, RGB(255,255,255));
			CPen* oldPen = pDC->SelectObject(&pen);
			pDC->MoveTo(2, 2);
			pDC->LineTo(3, 3);
			pDC->MoveTo(rc.Width()-3, 2);
			pDC->LineTo(rc.Width()-2, 3);
			pDC->MoveTo(2, CARDHEIGHT-3);
			pDC->LineTo(3, CARDHEIGHT-2);
			pDC->MoveTo(rc.Width()-3, CARDHEIGHT-3);
			pDC->LineTo(rc.Width()-2, CARDHEIGHT-2);
			pDC->SelectObject(oldPen);
		}
		else{
			CBitmap *oldBitmap;
			oldBitmap = m_MemDC.SelectObject(&m_BitmapCompatible);
			m_MemDC.DrawState(CPoint(0, 0), CSize(CARDWIDTH, CARDHEIGHT), m_bmpShirt, DST_BITMAP);
			pDC->StretchBlt(0, 0, rc.Width(), rc.Height(), &m_MemDC, 0, 0, CARDWIDTH, CARDHEIGHT, SRCCOPY);
			m_MemDC.SelectObject(oldBitmap);
		}
	}
	
	//pDC->RestoreDC(-1);

	Util_DeleteGdiObject((CGdiObject*)&m_BitmapCompatible);
	m_MemDC.DeleteDC();
	
	//return CWnd::OnEraseBkgnd(pDC);
	return TRUE;
}

//       
void CCard::CardClose(const bool& close)
{
	m_bIsFace = !close;
	Invalidate();
}



//     
void CCard::CardOpen(bool open, int card_width, int card_height)
{	
	staticCountProcess++;

	if(card_width == 0)
		card_width = CARDWIDTH;
	if(card_height == 0)
		card_height = CARDHEIGHT;
	DoOpenCard(open, card_width, card_height);

	staticCountProcess--;
}

//   
void __fastcall CCard::DoOpenCard(const bool& open, const int& card_width, const int& card_height)
{
	ResetCardSize(card_width, card_height);

	if(m_bOpenningCard == true)
	{
		m_bIsFace = true;
		Invalidate();
		return;
	}
	if(m_bAnimCards == false || staticStopProcess == true)
	{
		m_bIsFace = open;
		Invalidate();
		return;
	}

	//         
	//  
	if( m_bIsFace == true && open == true){
		return;
	}

	//           
	if( m_bIsFace == false && open == false){
		return;
	}

	RECT rc;
	GetClientRect(&rc);
	CPoint pt= GetCardPos();
	rc.left = pt.x;
	rc.top  = pt.y;
	rc.right  = card_width;
	rc.bottom = card_height;
	HDWP hdwp;
	HANDLE g_h = CreateEvent(0, true, false, "1");
	for(int i = 1; i <= card_width/2-5; i+=6)
	{
		if(m_bAnimCards == false || staticStopProcess == true)
		{
			i = card_width/2-5;
		}

		hdwp = BeginDeferWindowPos(1);
		DeferWindowPos(hdwp, this->m_hWnd, HWND_TOP, (int)rc.left + (int)i, 
				(int)rc.top, (int)rc.right - (int)(i*2), (int)rc.bottom, SWP_NOZORDER);
		EndDeferWindowPos(hdwp);
		
		WaitForSingleObject(g_h, 5);
	}

	int left   = rc.left + card_width/2;
	int top    = rc.top;
	int width  = rc.right - (card_width-6);
	int height = rc.bottom;
	hdwp = BeginDeferWindowPos(1);
	DeferWindowPos(hdwp, this->m_hWnd, HWND_TOP, left, top, width, height, SWP_NOZORDER);
	EndDeferWindowPos(hdwp);


	left = rc.left + card_width/2;
	//    
	m_bIsFace = open;
	Invalidate();
	g_h = CreateEvent(0, true, false, "1");
	for(int i = 1; i <= card_width/2-5; i+=6)
	{
		if(m_bAnimCards == false || staticStopProcess == true)
		{
			i = card_width/2-5;
		}

		hdwp = BeginDeferWindowPos(1);
		DeferWindowPos(hdwp, this->m_hWnd, HWND_TOP,left - (int)i, (int)rc.top, 1 + (int)(i*2), (int)rc.bottom, SWP_NOZORDER );
		EndDeferWindowPos(hdwp);
		
		WaitForSingleObject(g_h, 5);
	}

	left   = rc.left;
	top    = rc.top;
	width  = rc.right;
	height = rc.bottom;
	hdwp = BeginDeferWindowPos(1);
	DeferWindowPos(hdwp, this->m_hWnd, HWND_TOP, left, top, width, height, SWP_NOZORDER);
	EndDeferWindowPos(hdwp);
}

//        
HRESULT CCard::DrawImage(HDC hdc, const RECT& rcBounds)
{

	if (m_pPicture)
	{
		// Get the width and the height of the picture
		long hmWidth = 0, hmHeight = 0;
		m_pPicture->get_Width(&hmWidth);
		m_pPicture->get_Height(&hmHeight);

		// Convert himetric to pixels
		//int nWidth	= MulDiv(hmWidth, ::GetDeviceCaps(hdc, LOGPIXELSX), 0/*HIMETRIC_INCH*/);
		//int nHeight	= MulDiv(hmHeight, ::GetDeviceCaps(hdc, LOGPIXELSY), 0/*HIMETRIC_INCH*/);

		// Display the picture using IPicture::Render
		return m_pPicture->Render(
			hdc,							// [in] Handle of device context on which to render the image
			rcBounds.left,					// [in] Horizontal position of image in hdc
			rcBounds.top,					// [in] Vertical position of image in hdc
			rcBounds.right - rcBounds.left,	// [in] Horizontal dimension of destination rectangle
			rcBounds.bottom - rcBounds.top, // [in] Vertical dimension of destination rectangle
			0,								// [in] Horizontal offset in source picture
			hmHeight,						// [in] Vertical offset in source picture
			hmWidth,						// [in] Amount to copy horizontally in source picture
			-hmHeight,						// [in] Amount to copy vertically in source picture
			&rcBounds						// [in, optional] Pointer to position of destination for a metafile hdc
			);
	}

		return E_UNEXPECTED;
}


void CCard::ShowCard(bool show)
{
	show ? this->ShowWindow(SW_SHOW) : this->ShowWindow(SW_HIDE);
}



//      
void CCard::ResetCardSize(int card_width, int card_height)
{
	if(card_width == 0)
		card_width = CARDWIDTH;
	if(card_height == 0)
		card_height = CARDHEIGHT;

	CRgn Rgn;
	Rgn.CreateRoundRectRgn(0, 0, card_width+1, card_height+1, 4, 4);
	SetWindowRgn(Rgn, TRUE);
}


//////////////////////////////////////////////////////////////////////

CPack::CPack(void)
: m_PackPosX(10)
, m_PackPosY(10)
, m_NUMBERCARDS(36)// const   
, m_ID_Shirt(37)
{
	
}

CPack::~CPack(void)
{
	for(UINT i = 0; i < m_vecPack.size(); i++)
	{
		if( m_vecPack[i] != NULL)
			DELETEPOINT(m_vecPack[i]);
	}
	m_vecPack.clear();

}

//   
bool CPack::InitPack36(CWnd* pParent)
{
	//  
	HINSTANCE hRes = NULL;
	//init DLL 
	hRes=  ::LoadLibrary("CardK.dll");
	if(hRes == NULL)
	{
		MessageBox(pParent->m_hWnd, "     CardK.dll\n      www.interestprograms.ru.", "", MB_OK|MB_ICONWARNING);
	}
	else
		AfxSetResourceHandle(hRes);

	//m_ID_Shirt = 24;//NUMBERSHIRT;

	int value = 1, mast = 1;
	for(int i = 0; i < m_NUMBERCARDS; i++)
	{
		CCard* card = new CCard();
		card->CreateCard(CRect(0,0, CARDWIDTH, CARDHEIGHT), pParent, i+1, m_ID_Shirt);
		
		card->m_State = CPack::StateCards::m_ePack;
		card->m_Value = value;
		card->m_Mast  = mast;
		value++;
		if(value == 10)
		{
			value = 1;
			mast++;
		}

		//   
		if(card->m_Value == ValueDurak::m_durak6){
			card->m_PosValue = 0;
		}
		
		if(card->m_Value == ValueDurak::m_durak7){
			card->m_PosValue = 1;
		}
		
		if(card->m_Value == ValueDurak::m_durak8){
			card->m_PosValue = 2;
		}

		if(card->m_Value == ValueDurak::m_durak9){
			card->m_PosValue = 8;
		}

		if(card->m_Value == ValueDurak::m_durak10){
			card->m_PosValue = 4; 
		}
		
		if(card->m_Value == ValueDurak::m_durakV){
			card->m_PosValue = 3;
		}
		
		if(card->m_Value == ValueDurak::m_durakD){
			card->m_PosValue = 2;
		}

		if(card->m_Value == ValueDurak::m_durakK){
			card->m_PosValue = 1;
		}

		if(card->m_Value == ValueDurak::m_durakT){
			card->m_PosValue = 0;
		}
		
		//card->m_IndexPack = i;
		m_vecPack.push_back(card);
	}

	//resource is App
	AfxSetResourceHandle(AfxGetApp()->m_hInstance);
	::FreeLibrary(hRes);

	return true;
}


//   
bool CPack::SetShirt(const int number)
{
	if(m_vecPack.empty() == true) return false;

	
	//  
	HINSTANCE hRes = NULL;
	//init DLL 
	hRes=  ::LoadLibrary("CardK.dll");
	if(hRes == NULL)
	{
		MessageBox(NULL, "     CardK.dll\n      www.interestprograms.ru.", "", MB_OK|MB_ICONWARNING);
	}
	else
		AfxSetResourceHandle(hRes);
	

	m_ID_Shirt = 37 + number;

	int value = 1, mast = 1;
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		m_vecPack[i]->SetBmp(0, m_ID_Shirt);
		m_vecPack[i]->Invalidate();
	}

	//resource is App
	AfxSetResourceHandle(AfxGetApp()->m_hInstance);
	::FreeLibrary(hRes);
}

//     
CCard* CPack::GetCard(const int& index)
{
	if(m_vecPack.empty() == true) return NULL;

	// 
	if( (index + 1) > GetNumberCardsInPack())
		return NULL;

	
	return m_vecPack[index];
}

//      
void __fastcall CPack::SetPackPos(const int& x, const int& y)
{
	//         
	//   
	m_PackPosX = x;
	m_PackPosY = y;
	for(int i = (int)m_vecPack.size()-1; i >=0 ; i--)
	{
		if(	m_vecPack[i] != NULL &&
			m_vecPack[i]->m_State == StateCards::m_ePack)
		{
			m_vecPack[i]->SetCardPos(CPoint(x, y));
		}
	}

}

//    !
void __fastcall CPack::CardsToPack(void)
{
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(m_vecPack[i] == NULL) break;
		
		m_vecPack[i]->m_State = CPack::StateCards::m_ePack;
		m_vecPack[i]->m_Player = 0;
	
		m_vecPack[i]->ResetCardSize();
		m_vecPack[i]->CardClose(true);
		m_vecPack[i]->ShowCard(true);
		HDWP hdwp = BeginDeferWindowPos(1);
		DeferWindowPos(hdwp, m_vecPack[i]->m_hWnd, HWND_BOTTOM, 0, 0, CARDWIDTH, CARDHEIGHT, SWP_NOMOVE);
		EndDeferWindowPos(hdwp);
		m_vecPack[i]->SetCardPos(m_PackPosX, m_PackPosY);
	}

	//    
	CCard::staticStopProcess = false; 
}

//      
CCard* CPack::TakeCard( int *index_card/*     */)
{
	(*index_card) = -1;
	int numbercard = 0;
	while(numbercard != GetNumberCardsInPack())
	{
		if(m_vecPack.size() == 0) return NULL;

		if(	m_vecPack[numbercard] != NULL &&
			m_vecPack[numbercard]->m_State == CPack::StateCards::m_ePack)
		{
			*index_card = numbercard;
			return m_vecPack[numbercard];
		}
		numbercard++;
	}

	return NULL;
}


//    
void __fastcall CPack::ShufflePack()
{
	// 
	srand( (unsigned)time( NULL ) );

	int max_rand = 1 + rand()%23;

	int r;
	CCard* temp = NULL;
	for(int x = 0; x < max_rand; x++)
	{
		for(UINT i = 0; i < m_vecPack.size()*2; i++)
		{
			r = rand() % GetNumberCardsInPack();
			temp = m_vecPack[0];
			m_vecPack[0] = m_vecPack[r];
			m_vecPack[r] = temp;
		}
	}

}

//    
//         ,
//    
void CPack::ShufflePack(char mast[], char value[])
{
	ShufflePack();

	//      
	for(UINT x = 0; x < m_vecPack.size(); x++)
	{
		mast[x]  = m_vecPack[x]->m_Mast;
		value[x] = m_vecPack[x]->m_Value;
	}

}

//      
//       
//    
void __fastcall CPack::ArrayShuffle(char mast[], char value[])
{
	std::vector<CCard*> temp;
	for(int x = 0; x < GetNumberCardsInPack(); x++)
		for(int y = 0; y < GetNumberCardsInPack(); y++)
		{
			if(	m_vecPack[y] != NULL &&
				m_vecPack[y]->m_Mast == mast[x] && m_vecPack[y]->m_Value == value[x])
			{
				temp.push_back(m_vecPack[y]);
				break;
			}
		}

	ASSERT(temp.size() == GetNumberCardsInPack()); 

	for(char i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(m_vecPack[i] == NULL) break;

		m_vecPack[i] = temp[i];
	}
		
}

//      ,   ,     ..
//  open_all==true       
//  open_all==false       
void __fastcall CPack::OpenAllCards(bool open_all)
{
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(m_vecPack[i] == NULL) return;

		m_vecPack[i]->m_bOpenningCard = open_all;
		m_vecPack[i]->Invalidate();
	}
}

int CPack::GetShirt(void)
{
	return m_ID_Shirt;
}

//          CPack
void CPack::ShowAinmationCards(bool animation)
{
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(m_vecPack[i] != NULL)
			m_vecPack[i]->m_bAnimCards = animation;
	}
}

//     
bool CPack::IsShowAinmationCards(void)
{
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(m_vecPack[i] != NULL)
			if(m_vecPack[i]->m_bAnimCards == false)
				return false;
	}

	return true;
}

//     
bool CPack::IsPackFull(void)
{
	for(int i = 0; i < GetNumberCardsInPack(); i++)
	{
		if(	m_vecPack[i] != NULL &&
			m_vecPack[i]->m_State != CPack::StateCards::m_ePack)
			return false;
	}

	return true;
}

