// PagePublicSetting.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "PagePublicSetting.h"
#include ".\pagepublicsetting.h"


// CPagePublicSetting dialog

IMPLEMENT_DYNAMIC(CPagePublicSetting, CPropertyPage)

CPagePublicSetting::CPagePublicSetting()
	: CPropertyPage(IDD_PAGE_PUBLICSETTING)
	, m_NetGame(false)
{
}

CPagePublicSetting::~CPagePublicSetting()
{
}

void CPagePublicSetting::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	
}


BEGIN_MESSAGE_MAP(CPagePublicSetting, CPropertyPage)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CHECK_ANIM, OnBnClickedCheckAnim)
	ON_BN_CLICKED(IDC_CHECK_OPENCARDS, OnBnClickedCheckOpencards)
	ON_BN_CLICKED(IDC_CHECK_SOUND, OnBnClickedCheckSound)
	ON_BN_CLICKED(IDC_CHECK_DIFFICULTGAME, OnBnClickedCheckDifficultgame)
	ON_BN_CLICKED(IDC_CHECK_REQUESTNAME, OnBnClickedCheckRequestname)
	ON_BN_CLICKED(IDC_CHECK_CHAT, OnBnClickedCheckChat)

	ON_BN_CLICKED(IDC_RADIO_MONEY100, OnBnClickedRadioMoney100)
	ON_BN_CLICKED(IDC_RADIO_MONEY200, OnBnClickedRadioMoney200)
	ON_BN_CLICKED(IDC_RADIO_MONEY300, OnBnClickedRadioMoney300)
	
END_MESSAGE_MAP()


// CPagePublicSetting message handlers


BOOL CPagePublicSetting::OnInitDialog()
{
	CPropertyPage::OnInitDialog();


	((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->SetRange(0, 1500);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->SetLineSize(215);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->SetPos(750);
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->SetTicFreq(150);



	if(m_NetGame == true)
	{
		//       
		//     
		GetDlgItem(IDC_SLIDER_RATE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_OPENCARDS)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHECK_DIFFICULTGAME)->EnableWindow(FALSE);
	}
	else
	{
		//     
		//      
		GetDlgItem(IDC_CHECK_CHAT)->EnableWindow(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


//      
void CPagePublicSetting::SetSliderRate(int pos)
{
	((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->SetPos(pos);
}

void CPagePublicSetting::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int pos = 1500 - ((CSliderCtrl*)GetDlgItem(IDC_SLIDER_RATE))->GetPos();
	SendMainParent(IDC_SLIDER_RATE, pos);

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}


//    CMainFrame.
void CPagePublicSetting::SendMainParent(WPARAM wParam, LPARAM lParam)
{
	CPropertySheet* pParent = (CPropertySheet*)GetParent();
	if(pParent != NULL)
	{
		::SendMessage(pParent->m_psh.hwndParent, WM_PAGESETTING, wParam, lParam);
	}// if(pParent != NULL)
}


void CPagePublicSetting::OnBnClickedCheckAnim()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_ANIM));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_ANIM, check);
	}
}


void CPagePublicSetting::OnBnClickedCheckOpencards()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_OPENCARDS));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_OPENCARDS, check);
	}
}


void CPagePublicSetting::OnBnClickedCheckSound()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_SOUND));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_SOUND, check);
	}
}

void CPagePublicSetting::OnBnClickedCheckChat()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_CHAT));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_CHAT, check);
	}
}

void CPagePublicSetting::OnBnClickedCheckRequestname()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_REQUESTNAME));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_REQUESTNAME, check);
	}
}

void CPagePublicSetting::OnBnClickedRadioMoney100()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY100));
	if(pButton != NULL)
	{
		SendMainParent(IDC_RADIO_MONEY100, 1);
	}
}

void CPagePublicSetting::OnBnClickedRadioMoney200()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY200));
	if(pButton != NULL)
	{
		SendMainParent(IDC_RADIO_MONEY200, 1);
	}
}

void CPagePublicSetting::OnBnClickedRadioMoney300()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY300));
	if(pButton != NULL)
	{
		SendMainParent(IDC_RADIO_MONEY300, 1);
	}
}


//         
void CPagePublicSetting::SetCheckRadioMoney(const int amount_money)
{
	CButton* pButton = NULL;

	//    .
	switch(amount_money)
	{
	case 100:
	case 200:
	case 300:
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY100));
		pButton->SetCheck(BST_UNCHECKED);
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY200));
		pButton->SetCheck(BST_UNCHECKED);
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY300));
		pButton->SetCheck(BST_UNCHECKED);
		break;
	}

	//   .
	switch(amount_money)
	{
	case 100:
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY100));
		pButton->SetCheck(BST_UNCHECKED);
		break;
	case 200:
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY200));
		pButton->SetCheck(BST_UNCHECKED);
		break;
	case 300:
		pButton = ((CButton*)GetDlgItem(IDC_RADIO_MONEY300));
		pButton->SetCheck(BST_UNCHECKED);
		break;
	}
	
	if(pButton != NULL)
	{
		pButton->SetCheck(BST_CHECKED);
	}
}

void CPagePublicSetting::OnBnClickedCheckDifficultgame()
{
	CButton* pButton = ((CButton*)GetDlgItem(IDC_CHECK_DIFFICULTGAME));
	if(pButton != NULL)
	{
		BOOL check;
		if(pButton->GetCheck() == BST_CHECKED)
			check = TRUE;
		else
			check = FALSE;
		SendMainParent(IDC_CHECK_DIFFICULTGAME, check);
	}
}

//      
void CPagePublicSetting::SetCheckButtons(CheckButtons check_button)
{
	CButton* pButton = NULL;

	switch(check_button)
	{
	case chbAnim:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_ANIM));
		break;
	case chbOpencards:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_OPENCARDS));
		break;
	case chbSound:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_SOUND));
		break;
	case chbRequestname:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_REQUESTNAME));
		break;
	case chbDifficulty:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_DIFFICULTGAME));
		break;
	case chbChat:
		pButton = ((CButton*)GetDlgItem(IDC_CHECK_CHAT));
		break;
	}

	ASSERT(pButton != NULL);

	if(pButton != NULL)
	{
		pButton->SetCheck(BST_CHECKED);
	}

}


//    ,          .
void CPagePublicSetting::DisabledSetting(bool disabled)
{
	if(disabled == true)
	{
		GetDlgItem(IDC_RADIO_MONEY100)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_MONEY200)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_MONEY300)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_RADIO_MONEY100)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_MONEY200)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_MONEY300)->EnableWindow(TRUE);	
	}
}
