// PageView.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "PageView.h"
#include ".\pageview.h"

// CPageView dialog

IMPLEMENT_DYNAMIC(CPageView, CPropertyPage)
CPageView::CPageView()
	: CPropertyPage(IDD_PAGE_VIEW)
	, m_pParent(NULL)
{
}

CPageView::~CPageView()
{
}

void CPageView::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_SHIRTS, m_ListShirts);
	DDX_Control(pDX, IDC_LIST_TABLES, m_ListTables);
	DDX_Control(pDX, IDC_LIST_BG, m_ListBG);
}

BEGIN_MESSAGE_MAP(CPageView, CPropertyPage)
	ON_LBN_SELCHANGE(IDC_LIST_SHIRTS, OnLbnSelchangeListShirts)
	ON_LBN_SELCHANGE(IDC_LIST_TABLES, OnLbnSelchangeListTables)
	ON_LBN_SELCHANGE(IDC_LIST_BG, OnLbnSelchangeListBg)
	ON_LBN_SETFOCUS(IDC_LIST_SHIRTS, OnLbnSetfocusListShirts)
	ON_LBN_SETFOCUS(IDC_LIST_TABLES, OnLbnSetfocusListTables)
	ON_LBN_SETFOCUS(IDC_LIST_BG, OnLbnSetfocusListBg)
	ON_BN_CLICKED(IDC_BUTTON_SETSHIRTIMAGE, OnBnClickedSETSHIRTIMAGE)
	ON_BN_CLICKED(IDC_BUTTON_SETTABLEIMAGE, OnBnClickedSETTABLEIMAGE)
	ON_BN_CLICKED(IDC_BUTTON_SETBRUSHVIEW, OnBnClickedSETBRUSHVIEW)
END_MESSAGE_MAP()


// CPageView message handlers
BOOL CPageView::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_ListShirts.AddString(" 1");
	m_ListShirts.AddString(" 2");
	m_ListShirts.AddString(" 3");
	m_ListShirts.AddString(" 4");
	m_ListShirts.AddString(" 5");
	m_ListShirts.AddString(" 6");
	m_ListShirts.AddString("");

	m_ListShirts.SetCurSel(0);

	m_ListTables.AddString(" ");
	m_ListTables.AddString(" 1");
	m_ListTables.AddString(" 2");
	m_ListTables.AddString(" 3");
	m_ListTables.AddString(" 4");
	m_ListTables.AddString(" 5");
	m_ListTables.AddString("");

	m_ListTables.SetCurSel(1);

	m_ListBG.AddString(" 1");
	m_ListBG.AddString(" 2");
	m_ListBG.AddString(" 3");
	m_ListBG.AddString(" 4");
	m_ListBG.AddString(" 5");
	m_ListBG.AddString(" 6");
	m_ListBG.AddString(" 7");

	m_ListBG.SetCurSel(0);

	m_ListShirts.ModifyStyleEx(WS_EX_CLIENTEDGE, 0  );
	m_ListTables.ModifyStyleEx(WS_EX_CLIENTEDGE, 0  );
	m_ListBG.ModifyStyleEx(WS_EX_CLIENTEDGE, 0  );



	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//    CMainFrame
void CPageView::SendMainParent(WPARAM wParam, LPARAM lParam)
{
	if(m_pParent != NULL)
	{
		m_pParent->SendMessage(WM_PAGESETTING, wParam, lParam);
	}// if(pParent != NULL)
}
void CPageView::OnLbnSelchangeListShirts()
{
	int select = m_ListShirts.GetCurSel();
	SendMainParent(IDC_LIST_SHIRTS, (select + 1));
	if(select == 6)
		GetDlgItem(IDC_BUTTON_SETSHIRTIMAGE)->EnableWindow(TRUE);
	else
		GetDlgItem(IDC_BUTTON_SETSHIRTIMAGE)->EnableWindow(FALSE);
}

void CPageView::OnLbnSelchangeListTables()
{
	int select = m_ListTables.GetCurSel();
	SendMainParent(IDC_LIST_TABLES, (select + 1));
	if(select == 6)
		GetDlgItem(IDC_BUTTON_SETTABLEIMAGE)->EnableWindow(TRUE);
	else
		GetDlgItem(IDC_BUTTON_SETTABLEIMAGE)->EnableWindow(FALSE);
}

void CPageView::OnLbnSelchangeListBg()
{
	int select = m_ListBG.GetCurSel();
	SendMainParent(IDC_LIST_BG, (select + 1));
	if(select == 6)
		GetDlgItem(IDC_BUTTON_SETBRUSHVIEW)->EnableWindow(TRUE);
	else
		GetDlgItem(IDC_BUTTON_SETBRUSHVIEW)->EnableWindow(FALSE);
}

void CPageView::OnLbnSetfocusListShirts()
{
	SetGroupFocus(&m_ListShirts);
}


void CPageView::OnLbnSetfocusListTables()
{
	SetGroupFocus(&m_ListTables);
}

void CPageView::OnLbnSetfocusListBg()
{
	SetGroupFocus(&m_ListBG);
}

void CPageView::SetGroupFocus(CListBox* listbox)
{
	m_ListShirts.ModifyStyle(WS_BORDER, 0);
	m_ListTables.ModifyStyle(WS_BORDER, 0);
	m_ListBG.ModifyStyle(WS_BORDER, 0 );

	listbox->ModifyStyle(0, WS_BORDER );
	Invalidate();
}

void CPageView::SetTable(int number_table)
{
	m_ListTables.SetCurSel(number_table);

	//      
	//    " "
	OnLbnSelchangeListTables();
}

void CPageView::SetShirt(int number_shirt)
{
	m_ListShirts.SetCurSel(number_shirt);

	//      
	//    " "
	OnLbnSelchangeListShirts();
}

void CPageView::SetBG(int number_bg)
{
	m_ListBG.SetCurSel(number_bg);

	//      
	//       
	OnLbnSelchangeListBg();
}

void CPageView::OnBnClickedSETSHIRTIMAGE()
{
	CFileDialog FileOpenDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"(*.bmp;*.jpg;*.gif)|*.bmp;*.jpg;*.gif||", m_pParent);
	FileOpenDlg.m_pOFN->lpstrTitle = "    ";
	if(FileOpenDlg.DoModal() == IDOK)
	{
		m_strShirtImage = FileOpenDlg.GetPathName();
		SendMainParent(IDC_LIST_SHIRTS, 1000);
	}
}

void CPageView::OnBnClickedSETTABLEIMAGE()
{
	CFileDialog FileOpenDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"(*.bmp;*.jpg;*.gif)|*.bmp;*.jpg;*.gif||", m_pParent);
	FileOpenDlg.m_pOFN->lpstrTitle  = "    ";
	
	if(FileOpenDlg.DoModal() == IDOK)
	{
		m_strTableImage = FileOpenDlg.GetPathName();
		SendMainParent(IDC_LIST_TABLES, 1000);
	}
}

void CPageView::OnBnClickedSETBRUSHVIEW()
{
	CFileDialog FileOpenDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"(*.bmp)|*.bmp||", m_pParent);
	FileOpenDlg.m_pOFN->lpstrTitle  = "   ";
	
	if(FileOpenDlg.DoModal() == IDOK)
	{
		m_strBrushBG = FileOpenDlg.GetPathName();
		SendMainParent(IDC_LIST_BG, 1000);
	}
}